﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace CodeWalker.GameFiles
{

    
    public class MetaNamesUtil
    {


        public static string GetNameEnumCode()
        {
            //code to generate the enum code with the hash from the list of names
            StringBuilder sb = new StringBuilder();
            string[] names = ShaderParamNames.Split(new[] { "\r\n" }, StringSplitOptions.RemoveEmptyEntries);
            foreach (string name in names)
            {
                uint hash = JenkHash.GenHash(name/*.ToLower()*/, JenkHashInputEncoding.UTF8);
                sb.AppendFormat("{0} = {1},", name, hash);
                sb.AppendLine();
            }
            string result = sb.ToString();
            return result;
        }

        public static string ShaderParamNames = @"";//[redundant list removed]

    }





    public enum MetaName : uint
    {
        aabb = 293662904,
        AABB = 1666779607,
        AbilityType = 229841885,
        Action = 1705836299,
        activeChangesetConditions = 618424668,
        AdditiveDamageClipSet = 1159808383,
        AET_Directed_In_Place = 1450000159,
        AET_Flinch = 2886590336,
        AET_In_Place = 3552718780,
        AET_Interesting = 478982036,
        AET_Threatened = 1152560683,
        AET_Threatening = 56876971,
        aExplosionTagData = 2196546139,
        AFF_POOR = 1885794222,
        Affluence = 2895355855,
        Age = 2099622785,
        aircraftDownwashPtFxDist = 1452685083,
        aircraftDownwashPtFxEnabled = 1469712840,
        aircraftDownwashPtFxNameDefault = 461290670,
        aircraftDownwashPtFxNameDirt = 2734634606,
        aircraftDownwashPtFxNameFoliage = 2573299811,
        aircraftDownwashPtFxNameSand = 1320803722,
        aircraftDownwashPtFxNameWater = 1934771968,
        aircraftDownwashPtFxRange = 192247734,
        aircraftDownwashPtFxSpeedEvoMax = 632867260,
        aircraftDownwashPtFxSpeedEvoMin = 4072762094,
        aircraftSectionDamageSmokePtFxEnabled = 136971974,
        aircraftSectionDamageSmokePtFxName = 345776584,
        aircraftSectionDamageSmokePtFxRange = 2299979830,
        aircraftSectionDamageSmokePtFxSpeedEvoMax = 1864737051,
        aircraftSectionDamageSmokePtFxSpeedEvoMin = 3715270087,
        ALL = 3690519890,
        Allow = 1329228842,
        allowBonnetSlide = 1294495304,
        AllowCloseSpawning = 4019244692,
        ALTERNATE_VARIATIONS_FILE = 611054590,
        AmbientClipsForFlee = 1496688419,
        AmbulanceShouldRespondTo = 2153846297,
        Amount = 42366424,
        Amplitude = 946881915,
        anchor = 1880738441,
        ANCHOR_EARS = 119829315,
        ANCHOR_EYES = 1125276126,
        ANCHOR_HEAD = 2389455644,
        ANCHOR_LEFT_WRIST = 935290624,
        ANCHOR_RIGHT_WRIST = 1131235937,
        AnimalAudioObject = 1131698046,
        AnimatedModel = 1544926406,
        Animations = 212063203,
        AnimDict = 1027851728,
        AnimName = 1300132907,
        AP_LOW = 2695760829,
        AP_MEDIUM = 629290484,
        APF_ISBLENDAUTOREMOVE = 4147018654,
        APF_ISLOOPED = 829168795,
        Apply = 804826100,
        archetypeName = 2686689324,
        archetypes = 25836315,
        areas = 4258609502,
        assetName = 2591541189,
        assetType = 110101682,
        AT_TXD = 3870813049,
        AUDIO_DYNAMIXDATA = 2538787365,
        AUDIO_GAMEDATA = 2568179508,
        AUDIO_SOUNDDATA = 4061522791,
        AUDIO_SPEECHDATA = 2934881832,
        AUDIO_SYNTHDATA = 1488170759,
        AUDIO_WAVEPACK = 1781244916,
        audioApply = 636362136,
        audioId = 3218488635,
        AUDIOMESH_INDEXREMAPPING_FILE = 26529435,
        AutoOpenCloseRateTaper = 838139088,
        AutoOpenCosineAngleBetweenThreshold = 2537405501,
        AutoOpenRadiusModifier = 380434751,
        AutoOpenRate = 4024424870,
        AutoOpensForAllVehicles = 1314594320,
        AutoOpensForLawEnforcement = 711087453,
        AutoOpensForMPPlayerPedsOnly = 2116737868,
        AutoOpensForMPVehicleWithPedsOnly = 4004737101,
        AutoOpensForSPPlayerPedsOnly = 17022999,
        AutoOpensForSPVehicleWithPedsOnly = 883718936,
        AutoOpenVolumeOffset = 2598815900,
        availableInMpSp = 286077157,
        backfirePtFxEnabled = 3590298048,
        backfirePtFxName = 326241207,
        backfirePtFxRange = 2051678496,
        bAppliesContinuousDamage = 1994294878,
        bbMax = 3884623384,
        bbMin = 3656352310,
        bCanSetPedOnFire = 1975010672,
        bDamageObjects = 3087256498,
        bDamageVehicles = 410915188,
        BF_ALLOW_CONFRONT_FOR_TERRITORY_REACTIONS = 135224044,
        BF_BOOST_BRAVERY_IN_GROUP = 1233676580,
        BF_COWARDLY_FOR_SHOCKING_EVENTS = 2349079456,
        Bias = 2130430791,
        BICYCLE = 3348377513,
        bIgnoreExplodingEntity = 558484383,
        BIKE = 1039130067,
        blend = 3933447691,
        Blend = 3998560112,
        BlendOutDelta = 2689634897,
        BlendShapeFileName = 538335227,
        block = 3828602749,
        BLOODFX_FILE = 2150607422,
        bmax = 3220565995,
        bmin = 2028577215,
        bNoOcclusion = 1554370232,
        BOAT = 3921641754,
        boatBowPtFxEnabled = 3846459290,
        boatBowPtFxForwardName = 1639130517,
        boatBowPtFxKeelEvoMax = 237804409,
        boatBowPtFxKeelEvoMin = 3676512912,
        boatBowPtFxRange = 985220618,
        boatBowPtFxReverseName = 547727530,
        boatBowPtFxReverseOffset = 3858334001,
        boatBowPtFxScale = 1915459369,
        boatBowPtFxSpeedEvoMax = 1653246433,
        boatBowPtFxSpeedEvoMin = 2239940421,
        boatEntryPtFxEnabled = 2986953331,
        boatEntryPtFxName = 3178605558,
        boatEntryPtFxRange = 3592388731,
        boatEntryPtFxScale = 2701410410,
        boatEntryPtFxSpeedEvoMax = 2846825758,
        boatEntryPtFxSpeedEvoMin = 690983709,
        boatLowLodWakePtFxEnabled = 1609784914,
        boatLowLodWakePtFxName = 4184644587,
        boatLowLodWakePtFxRangeMax = 2835234692,
        boatLowLodWakePtFxRangeMin = 661173079,
        boatLowLodWakePtFxScale = 3728892023,
        boatLowLodWakePtFxSpeedEvoMax = 3584741482,
        boatLowLodWakePtFxSpeedEvoMin = 1014081258,
        boatPropellerPtFxBackwardSpeedEvoMax = 2824456943,
        boatPropellerPtFxBackwardSpeedEvoMin = 3685235291,
        boatPropellerPtFxDepthEvoMax = 1772973337,
        boatPropellerPtFxDepthEvoMin = 3807963294,
        boatPropellerPtFxEnabled = 620740022,
        boatPropellerPtFxForwardSpeedEvoMax = 4046105228,
        boatPropellerPtFxForwardSpeedEvoMin = 3958699285,
        boatPropellerPtFxName = 2372580323,
        boatPropellerPtFxRange = 333451303,
        boatPropellerPtFxScale = 2960340578,
        boatWashPtFxEnabled = 1083605797,
        boatWashPtFxName = 1782303759,
        boatWashPtFxRange = 3400904137,
        boatWashPtFxScale = 3769797352,
        boatWashPtFxSpeedEvoMax = 1641333397,
        boatWashPtFxSpeedEvoMin = 3421082045,
        bobble_base = 1417117096,
        bobble_head = 1789547068,
        bone = 282216227,
        boneMask = 593061963,
        boneTag = 702019504,
        BONETAG_HEAD = 3914473216,
        BONETAG_INVALID = 3548260605,
        BONETAG_L_CALF = 4031667174,
        BONETAG_L_CLAVICLE = 3253512823,
        BONETAG_L_FINGER22 = 222561854,
        BONETAG_L_FOOT = 1655517369,
        BONETAG_L_FOREARM = 2583642279,
        BONETAG_L_HAND = 3058573909,
        BONETAG_L_PH_HAND = 2994337423,
        BONETAG_L_THIGH = 2825836160,
        BONETAG_L_UPPERARM = 3728862758,
        BONETAG_NECK = 1526074386,
        BONETAG_NECK2 = 3577705298,
        BONETAG_PELVIS = 572940669,
        BONETAG_PELVIS1 = 2070754819,
        BONETAG_R_CALF = 1591530804,
        BONETAG_R_CLAVICLE = 623050371,
        BONETAG_R_FINGER22 = 1557592184,
        BONETAG_R_FOOT = 3872946345,
        BONETAG_R_FOREARM = 3269208355,
        BONETAG_R_HAND = 1128649107,
        BONETAG_R_PH_HAND = 1835505437,
        BONETAG_R_THIGH = 1692969046,
        BONETAG_R_UPPERARM = 868290042,
        BONETAG_ROOT = 102109035,
        BONETAG_SPINE_ROOT = 4085918559,
        BONETAG_SPINE0 = 2529646404,
        BONETAG_SPINE1 = 2239149219,
        BONETAG_SPINE2 = 740327916,
        BONETAG_SPINE3 = 2718199230,
        BONETAG_TAIL1 = 1278001105,
        BONETAG_TAIL2 = 2362982695,
        bOnlyAffectsLivePeds = 2543255645,
        bOnlyBulkyItemVariations = 3412263941,
        bonnet = 1704829083,
        boot = 3042873625,
        bottom = 4007699126,
        bPostProcessCollisionsWithNoForce = 1091620747,
        bPreventWaterExplosionVFX = 3664732218,
        BreakableByVehicle = 3427926298,
        BreakingImpulse = 1467901147,
        bsCentre = 3591926527,
        bsRadius = 2196293086,
        bSuppressCrime = 1060477616,
        bumper_f = 3886330357,
        bumper_r = 2370370867,
        bUseDistanceDamageCalc = 1929564509,
        CAiCoverClipVariationHelper__Tunables = 1889755865,
        camAnimatedCameraMetadata = 2493365232,
        camAnimatedShakeMetadata = 830598329,
        camAnimSceneDirectorMetadata = 3688863121,
        CAmbientLookAt__Tunables = 3791958970,
        CAmbientPedModelVariations = 949980109,
        camCatchUpHelperMetadata = 1074754094,
        camCinematicAnimatedCameraMetadata = 597434980,
        camCinematicBustedContextMetadata = 2582741472,
        camCinematicBustedShotMetadata = 46335367,
        camCinematicCameraManCameraMetadata = 1752694078,
        camCinematicCameraManShotMetadata = 3795997700,
        camCinematicCameraOperatorShakeSettings = 267450829,
        camCinematicCameraOperatorShakeTurbulenceSettings = 2761299644,
        camCinematicCameraOperatorShakeUncertaintySettings = 1672408332,
        camCinematicCraningCameraManShotMetadata = 644794406,
        camCinematicDirectorMetadata = 2947939407,
        camCinematicFallFromHeliContextMetadata = 3141653833,
        camCinematicFallFromHeliShotMetadata = 4001219648,
        camCinematicFirstPersonIdleCameraMetadata = 3500761789,
        camCinematicGroupCameraMetadata = 2180005320,
        camCinematicHeliChaseCameraMetadata = 385169240,
        camCinematicHeliTrackingShotMetadata = 50998987,
        camCinematicIdleCameraMetadata = 3818374703,
        camCinematicIdleShots = 3503595515,
        camCinematicInTrainAtStationContextMetadata = 3022638185,
        camCinematicInTrainContextMetadata = 3314933929,
        camCinematicInVehicleContextMetadata = 1660686749,
        camCinematicInVehicleCrashShotMetadata = 35962033,
        camCinematicInVehicleFirstPersonContextMetadata = 976409621,
        camCinematicInVehicleMultiplayerPassengerContextMetadata = 2822987935,
        camCinematicInVehicleOverriddenFirstPersonContextMetadata = 1737743598,
        camCinematicInVehicleWantedContextMetadata = 3656622133,
        camCinematicMissileKillShotMetadata = 947812684,
        camCinematicMountedCameraMetadata = 2185301869,
        camCinematicMountedCameraMetadataFirstPersonPitchOffset = 2402191709,
        camCinematicMountedCameraMetadataFirstPersonRoll = 4132129159,
        camCinematicMountedCameraMetadataLeadingLookSettings = 954561561,
        camCinematicMountedCameraMetadataLookAroundSettings = 1554281348,
        camCinematicMountedCameraMetadataMovementOnAccelerationSettings = 3508760093,
        camCinematicMountedCameraMetadataOrientationSpring = 356764392,
        camCinematicMountedCameraMetadataRelativePitchScalingToThrottle = 745700012,
        camCinematicMountedPartCameraMetadata = 3009480533,
        camCinematicOnFootAssistedAimingContextMetadata = 3749335843,
        camCinematicOnFootAssistedAimingKillShotMetadata = 2251342366,
        camCinematicOnFootFirstPersonIdleShotMetadata = 371427845,
        camCinematicOnFootIdleContextMetadata = 251156589,
        camCinematicOnFootIdleShotMetadata = 1361168617,
        camCinematicOnFootMeleeContextMetadata = 254446303,
        camCinematicOnFootMeleeShotMetadata = 341599647,
        camCinematicOnFootSpectatingContextMetadata = 4029911638,
        camCinematicParachuteCameraManShotMetadata = 4063985916,
        camCinematicParachuteContextMetadata = 13761107,
        camCinematicParachuteHeliShotMetadata = 3350745713,
        camCinematicPedCloseUpCameraMetadata = 3732353935,
        camCinematicPoliceExitVehicleShotMetadata = 3244599436,
        camCinematicPoliceHeliMountedShotMetadata = 216191320,
        camCinematicPoliceInCoverShotMetadata = 971556424,
        camCinematicPoliceRoadBlockShotMetadata = 1663387456,
        camCinematicPositionCameraMetadata = 3193773259,
        camCinematicScriptContextMetadata = 866723283,
        camCinematicScriptedMissionCreatorFailContextMetadata = 1368189925,
        camCinematicScriptedRaceCheckPointContextMetadata = 4197977312,
        camCinematicScriptRaceCheckPointShotMetadata = 1301482539,
        camCinematicShots = 3403418927,
        camCinematicSpectatorNewsChannelContextMetadata = 1655520052,
        camCinematicStuntCameraMetadata = 3215612005,
        camCinematicStuntJumpContextMetadata = 3436792018,
        camCinematicStuntJumpShotMetadata = 3180375976,
        camCinematicTrainPassengerShotMetadata = 1891076392,
        camCinematicTrainRoofMountedShotMetadata = 1375436400,
        camCinematicTrainStationShotMetadata = 4261417377,
        camCinematicTrainTrackingCameraMetadata = 2537902390,
        camCinematicTrainTrackShotMetadata = 2718877126,
        camCinematicTwoShotCameraMetadata = 2296445362,
        camCinematicVehicleBonnetShotMetadata = 3690068033,
        camCinematicVehicleConvertibleRoofShotMetadata = 4253546052,
        camCinematicVehicleGroupShotMetadata = 3216211679,
        camCinematicVehicleLowOrbitCameraMetadata = 1680076183,
        camCinematicVehicleLowOrbitShotMetadata = 357811358,
        camCinematicVehicleOrbitCameraInitalSettings = 3064456407,
        camCinematicVehicleOrbitCameraMetadata = 4218813220,
        camCinematicVehicleOrbitShotMetadata = 723416050,
        camCinematicVehiclePartShotMetadata = 2287426079,
        camCinematicVehicleTrackingCameraMetadata = 2837215026,
        camCinematicWaterCrashCameraMetadata = 1054960932,
        camCinematicWaterCrashShotMetadata = 2640788941,
        camCollisionMetadata = 201950034,
        camCollisionMetadataBuoyancySettings = 3616131743,
        camCollisionMetadataClippingAvoidance = 3777878985,
        camCollisionMetadataOcclusionSweep = 1331207488,
        camCollisionMetadataOrbitDistanceDamping = 2044384768,
        camCollisionMetadataPathFinding = 937440555,
        camCollisionMetadataPullBackTowardsCollision = 1759437459,
        camCollisionMetadataPushBeyondEntitiesIfClipping = 1986022537,
        camCollisionMetadataRotationTowardsLos = 1805808954,
        camControlHelperMetadata = 2587719592,
        camControlHelperMetadataLookAround = 565470605,
        camControlHelperMetaDataPrecisionAimSettings = 3449554353,
        camControlHelperMetadataViewModes = 3633454422,
        camControlHelperMetadataViewModeSettings = 517960737,
        camControlHelperMetadataZoom = 1487224137,
        camCustomTimedSplineCameraMetadata = 4009398869,
        camCutsceneDirectorMetadata = 3410125985,
        camDebugDirectorMetadata = 3499963834,
        camDepthOfFieldSettingsMetadata = 3604381381,
        camEnvelopeMetadata = 2722791558,
        Camera = 2997360705,
        cameraPos = 2339743138,
        camFirstPersonAimCameraMetadataHeadingCorrection = 1094369805,
        camFirstPersonHeadTrackingAimCameraMetadata = 3079183712,
        camFirstPersonPedAimCameraMetadata = 821570743,
        camFirstPersonShooterCameraMetadata = 3837693093,
        camFirstPersonShooterCameraMetadataCoverSettings = 2863258061,
        camFirstPersonShooterCameraMetadataOrientationSpring = 4197661848,
        camFirstPersonShooterCameraMetadataOrientationSpringLite = 1421319957,
        camFirstPersonShooterCameraMetadataRelativeAttachOrientationSettings = 1064503511,
        camFirstPersonShooterCameraMetadataSprintBreakOutSettings = 3371709132,
        camFirstPersonShooterCameraMetadataStickyAim = 2799165301,
        camFollowCameraMetadataFollowOrientationConing = 2364914607,
        camFollowCameraMetadataHighAltitudeZoomSettings = 418469874,
        camFollowCameraMetadataPullAroundSettings = 3437120378,
        camFollowCameraMetadataRollSettings = 1774242875,
        camFollowParachuteCameraMetadata = 736042439,
        camFollowParachuteCameraMetadataCustomSettings = 1574447900,
        camFollowPedCameraMetadata = 3759477553,
        camFollowPedCameraMetadataAssistedMovementAlignment = 559130398,
        camFollowPedCameraMetadataCustomViewModeSettings = 2553880007,
        camFollowPedCameraMetadataDivingShakeSettings = 2182445161,
        camFollowPedCameraMetadataHighFallShakeSettings = 2518615630,
        camFollowPedCameraMetadataLadderAlignment = 947799964,
        camFollowPedCameraMetadataOrbitPitchLimitsForOverheadCollision = 1431341429,
        camFollowPedCameraMetadataPushBeyondNearbyVehiclesInRagdollSettings = 2530185515,
        camFollowPedCameraMetadataRappellingAlignment = 1129712783,
        camFollowPedCameraMetadataRunningShakeSettings = 2053748298,
        camFollowPedCameraMetadataSwimmingShakeSettings = 4069495749,
        camFollowVehicleCameraMetadata = 420909885,
        camFollowVehicleCameraMetadataDuckUnderOverheadCollisionSettings = 4113023525,
        camFollowVehicleCameraMetadataDuckUnderOverheadCollisionSettingsCapsuleSettings = 3720026770,
        camFollowVehicleCameraMetadataHandBrakeSwingSettings = 2830469256,
        camFollowVehicleCameraMetadataHighSpeedShakeSettings = 2477380333,
        camFollowVehicleCameraMetadataHighSpeedZoomSettings = 2338842389,
        camFollowVehicleCameraMetadataVerticalFlightModeSettings = 62698329,
        camFollowVehicleCameraMetadataWaterEntryShakeSettings = 3274567537,
        camFreeCameraMetadata = 569456131,
        camGameplayDirectorMetadata = 1800753065,
        camGameplayDirectorMetadataExplosionShakeSettings = 2835005341,
        camGameplayDirectorMetadataVehicleCustomSettings = 3404668154,
        camHintHelperMetadata = 939949516,
        camHintHelperMetadataPivotPositionAdditive = 242159927,
        camInconsistentBehaviourZoomHelperAirborneSettings = 3999425876,
        camInconsistentBehaviourZoomHelperDetectFastCameraTurnSettings = 193557158,
        camInconsistentBehaviourZoomHelperDetectSuddenMovementSettings = 2547763044,
        camInconsistentBehaviourZoomHelperLosSettings = 2655036129,
        camInconsistentBehaviourZoomHelperMetadata = 589272335,
        camLongSwoopSwitchHelperMetadata = 3366863628,
        camLookAheadHelperMetadata = 1630118580,
        camLookAtDampingHelperMetadata = 2621748074,
        camMarketingAToBCameraMetadata = 2461291580,
        camMarketingDirectorMetadata = 1412464790,
        camMarketingDirectorMetadataMode = 1136544428,
        camMarketingFreeCameraMetadata = 1284661433,
        camMarketingFreeCameraMetadataInputResponse = 624552429,
        camMarketingMountedCameraMetadata = 925580290,
        camMarketingOrbitCameraMetadata = 545216445,
        camMarketingStickyCameraMetadata = 915237293,
        camMetadataStore = 1634862667,
        camMotionBlurSettingsMetadata = 2215393933,
        camNearClipScannerMetadata = 2769283405,
        camOscillatorMetadata = 1877334503,
        camPreferredShotSelectionType = 2475841577,
        camReplayBaseCameraMetadataCollisionSettings = 1965600814,
        camReplayBaseCameraMetadataInputResponse = 3315215408,
        camReplayDirectorMetadata = 3250236667,
        camReplayFreeCameraMetadata = 3833530058,
        camReplayPresetCameraMetadata = 3519845310,
        camReplayRecordedCameraMetadata = 68919197,
        camRoundedSplineCameraMetadata = 4144888485,
        camScriptDirectorMetadata = 808165906,
        camScriptedCameraMetadata = 2249792487,
        camScriptedFlyCameraMetadata = 201638894,
        camScriptedFlyCameraMetadataInputResponse = 2912311349,
        camSeatSpecificCameras = 3206558883,
        camShake = 2812731727,
        camShakeMetadata = 2610893148,
        camShakeMetadataFrameComponent = 1092637061,
        camShakeName = 3155961353,
        camShakeRollOffScaling = 1058165836,
        camShortRotationSwitchHelperMetadata = 4216220206,
        camShortTranslationSwitchHelperMetadata = 1635202674,
        camShortZoomInOutSwitchHelperMetadata = 1845372544,
        camShortZoomToHeadSwitchHelperMetadata = 3608544718,
        camSmoothedSplineCameraMetadata = 2992118265,
        camSpeedRelativeShakeSettingsMetadata = 3163469773,
        camSpringMountMetadata = 545475055,
        camSwitchCameraMetadata = 3778407244,
        camSwitchDirectorMetadata = 1186645804,
        camSyncedSceneDirectorMetadata = 3842242989,
        camThirdPersonCameraMetadataBasePivotPosition = 2562557362,
        camThirdPersonCameraMetadataBasePivotPositionRollSettings = 3378401281,
        camThirdPersonCameraMetadataBuoyancySettings = 4280883922,
        camThirdPersonCameraMetadataCollisionFallBackPosition = 2931931466,
        camThirdPersonCameraMetadataCustomBoundingBoxSettings = 542523046,
        camThirdPersonCameraMetadataLookOverSettings = 1204861982,
        camThirdPersonCameraMetadataPivotOverBoungingBoxSettings = 70704803,
        camThirdPersonCameraMetadataPivotPosition = 3548788069,
        camThirdPersonCameraMetadataQuadrupedalHeightSpring = 2372917588,
        camThirdPersonCameraMetadataStealthZoomSettings = 1308532518,
        camThirdPersonCameraMetadataVehicleOnTopOfVehicleCollisionSettings = 1457190622,
        camThirdPersonPedAimCameraMetadata = 1732613077,
        camThirdPersonPedAimCameraMetadataLockOnOrbitDistanceSettings = 2689046040,
        camThirdPersonPedAimCameraMetadataLockOnTargetDampingSettings = 810467818,
        camThirdPersonPedAimInCoverCameraMetadata = 3583421172,
        camThirdPersonPedAimInCoverCameraMetadataAimingSettings = 2711282760,
        camThirdPersonPedAimInCoverCameraMetadataLowCoverSettings = 4274825405,
        camThirdPersonPedAssistedAimCameraCinematicMomentSettings = 2799730898,
        camThirdPersonPedAssistedAimCameraInCoverSettings = 2194812563,
        camThirdPersonPedAssistedAimCameraLockOnAlignmentSettings = 2731233901,
        camThirdPersonPedAssistedAimCameraMetadata = 4075428929,
        camThirdPersonPedAssistedAimCameraPivotScalingSettings = 774378567,
        camThirdPersonPedAssistedAimCameraPlayerFramingSettings = 1026402136,
        camThirdPersonPedAssistedAimCameraRecoilShakeScalingSettings = 3357216290,
        camThirdPersonPedAssistedAimCameraRunningShakeSettings = 1609808531,
        camThirdPersonPedAssistedAimCameraShakeActivityScalingSettings = 3550987017,
        camThirdPersonPedAssistedAimCameraShootingFocusSettings = 4025041103,
        camThirdPersonPedMeleeAimCameraMetadata = 3247898661,
        camThirdPersonVehicleAimCameraMetadata = 1836891244,
        camTimedSplineCameraMetadata = 2703512219,
        camVehicleCustomSettingsMetadata = 2297662625,
        camVehicleCustomSettingsMetadataAdditionalBoundScalingVehicleSettings = 2484857206,
        camVehicleCustomSettingsMetadataDoorAlignmentSettings = 690471002,
        camVehicleCustomSettingsMetadataExitSeatPhaseForCameraExitSettings = 2756864235,
        camVehicleCustomSettingsMetadataInvalidCinematcShotsRefsForVehicleSettings = 4239733162,
        camVehicleCustomSettingsMetadataMultiplayerPassengerCameraHashSettings = 695621723,
        camVehicleCustomSettingsMetadataSeatSpecficCameras = 1805758296,
        CAnimSpeedUps__Tunables = 1899092416,
        CanRideBikeWithNoHelmet = 2247732941,
        CanSpawnInCar = 2174732092,
        CantUse = 4039535360,
        CapsuleHalfHeight = 2163883074,
        CapsuleHalfWidth = 629093761,
        CapsuleLen = 3235184882,
        CapsuleRadius = 1996975203,
        CapsuleZOffset = 1054694912,
        CAR = 185025060,
        CARCOLS_FILE = 869804114,
        carModel = 3176005905,
        CBaseArchetypeDef = 2195127427,
        CBikeLeanAngleHelper__Tunables = 1450700199,
        CCarGen = 1860713439,
        CClipScalingHelper__Tunables = 3772901649,
        CCombatTaskManager__Tunables = 1555503841,
        CCreatureMetaData = 2042092773,
        CCurve = 608533002,
        CCurveSet = 2222014563,
        CDataFileMgr__ContentsOfDataFileXml = 1736702710,
        CDispatchAdvancedSpawnHelper__Tunables = 91788279,
        CDispatchHelperSearchInAutomobile__Tunables = 587339511,
        CDispatchHelperSearchInBoat__Tunables = 2880812777,
        CDispatchHelperSearchInHeli__Tunables = 1963636404,
        CDispatchHelperSearchOnFoot__Tunables = 2463141505,
        CDispatchHelperVolumes__Tunables = 3789346099,
        CDispatchSpawnHelper__Tunables = 487533277,
        CDistantLODLight = 2033467892,
        CDoorTuningFile = 2411310721,
        CDynamicCoverHelper__Tunables = 3153023901,
        centerAndRadius = 4089746177,
        CEntityDef = 3461354627,
        CEventAgitated__Tunables = 2874507431,
        CEventCrimeCryForHelp__Tunables = 2970598878,
        CEventEncroachingPed__Tunables = 30996625,
        CEventExplosionHeard__Tunables = 2586882546,
        CEventFootStepHeard__Tunables = 2570549492,
        CEventGunAimedAt__Tunables = 1810003585,
        CEventGunShot__Tunables = 2246785633,
        CEventMeleeAction__Tunables = 2580170005,
        CEventPedJackingMyVehicle__Tunables = 3230173079,
        CEventPotentialBeWalkedInto__Tunables = 447216401,
        CEventPotentialBlast__Tunables = 3804045499,
        CEventPotentialGetRunOver__Tunables = 4074745581,
        CEventRequestHelp__Tunables = 1097617571,
        CEventRespondedToThreat__Tunables = 1657862556,
        CEventShocking__Tunables = 2688422386,
        CEventSuspiciousActivity__Tunables = 2370193555,
        CExplosionInfoManager = 254220034,
        CExtensionDefAudioCollisionSettings = 366926375,
        CExtensionDefAudioEmitter = 637823035,
        CExtensionDefBuoyancy = 749982947,
        CExtensionDefDoor = 1965932561,
        CExtensionDefExplosionEffect = 104349545,
        CExtensionDefExpression = 3870521079,
        CExtensionDefLadder = 2182960161,
        CExtensionDefLightEffect = 663891011,
        CExtensionDefLightShaft = 2718997053,
        CExtensionDefParticleEffect = 975627745,
        CExtensionDefProcObject = 2565191912,
        CExtensionDefSpawnPoint = 3300062776,
        CExtensionDefSpawnPointOverride = 2716862120,
        CExtensionDefWindDisturbance = 569228403,
        CFiringPatternInfo = 4139644871,
        CGrabHelper__Tunables = 1898505781,
        Chances = 3434267272,
        changeSetName = 3618800523,
        chassis = 3558367838,
        CHDTxdAssetBinding = 1501994083,
        childName = 204594422,
        children = 240949893,
        CLegIkSolver__Tunables = 841524051,
        CLevelData = 75111904,
        CLightAttrDef = 4115341947,
        Clip = 547633373,
        CLIP_SETS_FILE = 4136207125,
        clipDictionaryMetadatas = 3037672124,
        clipDictionaryName = 635311839,
        ClipDictionaryName = 2571958159,
        clipItems = 3294768058,
        clips = 1731275751,
        ClipSet = 230522063,
        ClipSetId = 1769383946,
        clipSets = 2366522350,
        ClipSets = 2460310938,
        CLODLight = 2276214072,
        CLookAtHistory__Tunables = 4214737672,
        CMapData = 3545841574,
        CMapTypes = 3649811809,
        CMiniMap__Tunables = 4077958042,
        CMloArchetypeDef = 273704021,
        CMloEntitySet = 3601308153,
        CMloInstanceDef = 164374718,
        CMloPortalDef = 2572186314,
        CMloRoomDef = 186126833,
        CMloTimeCycleModifier = 807246248,
        CMultiTxdRelationship = 1261337422,
        CNmMessage = 540147835,
        CNmParameterBool = 3201838637,
        CNmParameterFloat = 2458347956,
        CNmParameterInt = 1429899100,
        CNmParameterRandomFloat = 3855903374,
        CNmParameterRandomInt = 213806608,
        CNmParameterResetMessage = 3594683582,
        CNmParameterString = 2290405727,
        CNmParameterVector = 1886176625,
        CNmTuningSet = 1903166467,
        col = 2082703339,
        collisionBone = 3234051813,
        CollisionData = 3547055785,
        CollisionRadius = 2961500813,
        color = 3914595625,
        Color = 1308845671,
        colors = 140995175,
        colour = 1541149667,
        CombatInfo = 894792629,
        Component = 3344490581,
        components = 3094514372,
        compositeEntityTypes = 1709823211,
        CompRestrictions = 1292693219,
        CONDITIONAL_ANIMS_FILE = 7003891,
        CONTENT_UNLOCKING_META_FILE = 138872183,
        contentChangeSets = 614695604,
        contents = 780522884,
        CONTENTS_ANIMATION = 1729429563,
        CONTENTS_CUTSCENE = 1341504475,
        CONTENTS_DLC_MAP_DATA = 2008833657,
        CONTENTS_LODS = 129500478,
        CONTENTS_MAP = 3584173080,
        CONTENTS_PEDS = 2150818969,
        CONTENTS_PROPS = 85688491,
        CONTENTS_VEHICLES = 3204813008,
        Context = 2518983606,
        corners = 1329770163,
        CPackFileMetaData = 2477165103,
        CPedCompExpressionData = 3105947251,
        CPedModelInfo__InitDataList = 3715594014,
        CPedModelInfo__PersonalityDataList = 2428131759,
        CPedPropExpressionData = 2871393870,
        CPedTargetEvaluator__Tunables = 1616944729,
        CPedTargetting__Tunables = 3572343040,
        CPlayerCoverClipVariationHelper__Tunables = 3847977171,
        CPlayerInfo__sPlayerStatInfo = 1168828738,
        CPlayerInfo__sSprintControlData = 2225340824,
        CPlayerInfo__Tunables = 3763924699,
        CPlayerPedTargeting__Tunables = 1955283657,
        CPoliceBoatDispatch__Tunables = 308678703,
        CPrioritizedClipSetRequestManager__Tunables = 76934329,
        CProceduralInfo = 4283490117,
        CPtFxAssetDependencyInfo = 3936596588,
        CPtFxAssetInfoMgr = 3599498566,
        CRandomEventManager__Tunables = 3308217727,
        CreatureMetadataName = 982286538,
        CRelationshipManager__Tunables = 1682166943,
        Crimes = 944438733,
        CScenarioClipHelper__Tunables = 1707736265,
        CScenarioPointGroup = 3383680063,
        CScenarioPointManifest = 1425675487,
        CScenarioPointRegionDef = 1251976652,
        CShaderVariableComponent = 3881120539,
        CSituationalClipSetStreamer__Tunables = 1395325338,
        CTacticalAnalysis__Tunables = 1413047452,
        CTacticalAnalysisCoverPoints__Tunables = 3043164413,
        CTacticalAnalysisCoverPointSearch__Tunables = 2640991648,
        CTacticalAnalysisNavMeshPoints__Tunables = 1220308217,
        CTargettingDifficultyInfo = 1135093158,
        CTaskAdvance__Tunables = 166066110,
        CTaskAgitated__Tunables = 451717787,
        CTaskAimAndThrowProjectile__Tunables = 920055786,
        CTaskAimFromGround__Tunables = 1016413941,
        CTaskAimGunBlindFire__Tunables = 3400346520,
        CTaskAimGunFromCoverIntro__Tunables = 675160047,
        CTaskAimGunFromCoverOutro__Tunables = 753314165,
        CTaskAimGunOnFoot__Tunables = 71881945,
        CTaskAimGunVehicleDriveBy__Tunables = 3042947166,
        CTaskAmbientClips__Tunables = 1589125251,
        CTaskAnimatedHitByExplosion__Tunables = 1117516593,
        CTaskArrestPed__Tunables = 1399891452,
        CTaskBoatChase__Tunables = 3798971738,
        CTaskBoatCombat__Tunables = 2409668190,
        CTaskBoatStrafe__Tunables = 3036495892,
        CTaskCallPolice__Tunables = 2834037164,
        CTaskCarReactToVehicleCollision__Tunables = 2728841566,
        CTaskChat__Tunables = 52767132,
        CTaskCloseVehicleDoorFromInside__Tunables = 3615161210,
        CTaskCombat__Tunables = 1035504443,
        CTaskCombatAdditionalTask__Tunables = 4286320209,
        CTaskCombatFlank__Tunables = 3480084478,
        CTaskComplexEvasiveStep__Tunables = 1335476290,
        CTaskConfront__Tunables = 150142004,
        CTaskConversationHelper__Tunables = 754470627,
        CTaskCoupleScenario__Tunables = 44269074,
        CTaskCover__Tunables = 3452806650,
        CTaskCowerScenario__Tunables = 27789385,
        CTaskDamageElectric__Tunables = 856265530,
        CTaskDraggingToSafety__Tunables = 4043706236,
        CTaskDyingDead__Tunables = 2675734391,
        CTaskEnterCover__Tunables = 1433330874,
        CTaskEnterVehicle__Tunables = 1027962175,
        CTaskEnterVehicleAlign__Tunables = 1636991334,
        CTaskEnterVehicleSeat__Tunables = 135393357,
        CTaskExhaustedFlee__Tunables = 633079219,
        CTaskExitCover__Tunables = 3296810549,
        CTaskExitVehicle__Tunables = 4141614587,
        CTaskExitVehicleSeat__Tunables = 4292350695,
        CTaskFall__Tunables = 3858033844,
        CTaskFishLocomotion__Tunables = 528773834,
        CTaskFlyingWander__Tunables = 2593718369,
        CTaskFlyToPoint__Tunables = 2856283273,
        CTaskGetUp__Tunables = 1454643673,
        CTaskGoToScenario__Tunables = 342235337,
        CTaskGrowlAndFlee__Tunables = 3882342074,
        CTaskGun__Tunables = 1283860553,
        CTaskHeliChase__Tunables = 4167522072,
        CTaskHeliCombat__Tunables = 1828825613,
        CTaskHelicopterStrafe__Tunables = 3763664820,
        CTaskHeliOrderResponse__Tunables = 162290274,
        CTaskHeliPassengerRappel__Tunables = 3828979530,
        CTaskHumanLocomotion__Tunables = 2920137037,
        CTaskInCover__Tunables = 1340552235,
        CTaskIntimidate__Tunables = 1888161203,
        CTaskInVehicleBasic__Tunables = 3591430584,
        CTaskInvestigate__Tunables = 2122351816,
        CTaskJump__Tunables = 1477206380,
        CTaskMeleeActionResult__Tunables = 1673636385,
        CTaskMotionAiming__Tunables = 1860470777,
        CTaskMotionBasicLocomotionLowLod__Tunables = 835509391,
        CTaskMotionInAutomobile__Tunables = 175867186,
        CTaskMotionInCover__Tunables = 1914830328,
        CTaskMotionInTurret__Tunables = 2020941567,
        CTaskMotionInVehicle__Tunables = 2450186166,
        CTaskMotionOnBicycle__Tunables = 1415781118,
        CTaskMotionOnBicycleController__Tunables = 1645332033,
        CTaskMotionSwimming__Tunables = 1000070523,
        CTaskMotionTennis__Tunables = 3629609639,
        CTaskMoveCombatMounted__Tunables = 1568594793,
        CTaskMoveCrossRoadAtTrafficLights__Tunables = 2381559732,
        CTaskMoveFollowNavMesh__Tunables = 418889424,
        CTaskMoveToTacticalPoint__Tunables = 2603381663,
        CTaskMoveWithinAttackWindow__Tunables = 938139729,
        CTaskNMBalance__Tunables = 4156771533,
        CTaskNMBehaviour__Tunables = 1424285270,
        CTaskNMBrace__Tunables = 959283411,
        CTaskNMBuoyancy__Tunables = 2908480529,
        CTaskNMControl__Tunables = 208512313,
        CTaskNMDraggingToSafety__Tunables = 4274630537,
        CTaskNMDrunk__Tunables = 1927528235,
        CTaskNMElectrocute__Tunables = 1986788875,
        CTaskNMExplosion__Tunables = 3668321041,
        CTaskNMFlinch__Tunables = 1394958084,
        CTaskNMHighFall__Tunables = 4010904374,
        CTaskNMInjuredOnGround__Tunables = 3943948180,
        CTaskNMJumpRollFromRoadVehicle__Tunables = 465597172,
        CTaskNMOnFire__Tunables = 749058568,
        CTaskNMPrototype__Tunables = 2697213281,
        CTaskNMPrototype__Tunables__TimedTuning = 1783260611,
        CTaskNMRiverRapids__Tunables = 2208098656,
        CTaskNMShot__Tunables = 365558263,
        CTaskNMSimple__Tunables = 1759871612,
        CTaskNMThroughWindscreen__Tunables = 701095463,
        CTaskOpenVehicleDoorFromOutside__Tunables = 4000867050,
        CTaskParachute__Tunables = 330647109,
        CTaskParachuteObject__Tunables = 533009545,
        CTaskPlaneChase__Tunables = 3362905475,
        CTaskPlayerDrive__Tunables = 2233320042,
        CTaskPlayerOnFoot__Tunables = 2843912235,
        CTaskPoliceOrderResponse__Tunables = 1572997428,
        CTaskPursueCriminal__Tunables = 1017737308,
        CTaskQuadLocomotion__Tunables = 3451166416,
        CTaskRageRagdoll__Tunables = 4111703670,
        CTaskRappel__Tunables = 583393603,
        CTaskReactAimWeapon__Tunables = 3431679747,
        CTaskReactAndFlee__Tunables = 1455936464,
        CTaskReactInDirection__Tunables = 1160501277,
        CTaskReactToBeingAskedToLeaveVehicle__Tunables = 2747883046,
        CTaskReactToBuddyShot__Tunables = 3060185515,
        CTaskReactToExplosion__Tunables = 1714101654,
        CTaskReactToImminentExplosion__Tunables = 2053606685,
        CTaskReactToPursuit__Tunables = 3823017031,
        CTaskRideTrain__Tunables = 85139718,
        CTaskScenarioFlee__Tunables = 4223438874,
        CTaskSearch__Tunables = 2186129008,
        CTaskSearchBase__Tunables = 1006486559,
        CTaskSearchForUnknownThreat__Tunables = 3552809742,
        CTaskSearchInAutomobile__Tunables = 3157865989,
        CTaskSearchInBoat__Tunables = 3740707804,
        CTaskSearchInHeli__Tunables = 2902745725,
        CTaskSearchOnFoot__Tunables = 1589612569,
        CTaskSharkAttack__Tunables = 2411903884,
        CTaskSharkCircle__Tunables = 3798074522,
        CTaskShockingEvent__Tunables = 2668698466,
        CTaskShockingEventBackAway__Tunables = 1421095933,
        CTaskShockingEventGoto__Tunables = 3634782675,
        CTaskShockingEventHurryAway__Tunables = 3936521982,
        CTaskShockingEventReact__Tunables = 1524084241,
        CTaskShockingEventReactToAircraft__Tunables = 1470816321,
        CTaskShockingEventStopAndStare__Tunables = 1473719990,
        CTaskShockingEventWatch__Tunables = 4159743939,
        CTaskShockingPoliceInvestigate__Tunables = 2727614619,
        CTaskShootOutTire__Tunables = 3623406952,
        CTaskShove__Tunables = 2315221829,
        CTaskShoved__Tunables = 2184485071,
        CTaskSmartFlee__Tunables = 2929340853,
        CTaskStandGuard__Tunables = 928089637,
        CTaskStealVehicle__Tunables = 3788906738,
        CTaskSwapWeapon__Tunables = 756021342,
        CTaskSwatOrderResponse__Tunables = 1687602234,
        CTaskSwimmingWander__Tunables = 581692275,
        CTaskTakeOffPedVariation__Tunables = 2581463145,
        CTaskTargetUnreachable__Tunables = 1996880107,
        CTaskTargetUnreachableInExterior__Tunables = 1858966752,
        CTaskTargetUnreachableInInterior__Tunables = 2878804031,
        CTaskTrainBase__Tunables = 2321692150,
        CTaskTryToGrabVehicleDoor__Tunables = 2780911905,
        CTaskUnalerted__Tunables = 3631212269,
        CTaskUseScenario__Tunables = 4286728767,
        CTaskUseVehicleScenario__Tunables = 1105517236,
        CTaskVariedAimPose__Tunables = 572125765,
        CTaskVault__Tunables = 4107041159,
        CTaskVehicleApproach__Tunables = 3998182611,
        CTaskVehicleBlock__Tunables = 946218496,
        CTaskVehicleBlockBackAndForth__Tunables = 3195863117,
        CTaskVehicleBlockBrakeInFront__Tunables = 1783020311,
        CTaskVehicleBlockCruiseInFront__Tunables = 2600077603,
        CTaskVehicleChase__Tunables = 1182936554,
        CTaskVehicleCombat__Tunables = 1479019922,
        CTaskVehicleCrash__Tunables = 3962616343,
        CTaskVehicleCruiseBoat__Tunables = 3100673805,
        CTaskVehicleDeadDriver__Tunables = 2144691340,
        CTaskVehicleFlee__Tunables = 195975428,
        CTaskVehicleFleeBoat__Tunables = 1082281615,
        CTaskVehicleFSM__Tunables = 2154756726,
        CTaskVehicleGoToBoat__Tunables = 1874670628,
        CTaskVehicleGoToHelicopter__Tunables = 505312818,
        CTaskVehicleGoToPlane__Tunables = 2216414081,
        CTaskVehicleGoToPointWithAvoidanceAutomobile__Tunables = 305265911,
        CTaskVehicleLandPlane__Tunables = 2468823445,
        CTaskVehicleMissionBase__Tunables = 3839812632,
        CTaskVehicleParkNew__Tunables = 1266857276,
        CTaskVehiclePersuit__Tunables = 424095714,
        CTaskVehiclePlaneChase__Tunables = 2639568629,
        CTaskVehiclePullAlongside__Tunables = 3971388892,
        CTaskVehiclePursue__Tunables = 1465682442,
        CTaskVehicleRam__Tunables = 4205884753,
        CTaskVehicleShotTire__Tunables = 4029377803,
        CTaskVehicleSpinOut__Tunables = 1106913269,
        CTaskWalkAway__Tunables = 206304570,
        CTaskWander__Tunables = 3543621225,
        CTaskWanderInArea__Tunables = 711403403,
        CTaskWanderingScenario__Tunables = 4183061553,
        CTaskWitness__Tunables = 1436906951,
        CTimeArchetypeDef = 1991296364,
        CTimeCycleModifier = 1733268304,
        CustomTriggerBox = 2579426011,
        CVehicleClipRequestHelper__Tunables = 2857018690,
        CVehicleModelInfoVarGlobal = 3184659407,
        CVehicleModelInfoVariation = 746362187,
        CVehicleScenarioManager__AttractorTuning__Tunables = 1138425769,
        CVfxVehicleInfo = 2566559812,
        CVfxVehicleInfoMgr = 13081091,
        CWanted__Tunables = 2938521871,
        CWantedHelicopterDispatch__Tunables = 3681116455,
        CWildlifeManager__Tunables = 3899878125,
        damageAtCentre = 626304432,
        damageAtEdge = 1456455832,
        dataFiles = 4164602339,
        DECALS_FILE = 721270417,
        decayFactor = 2187394038,
        DecisionMakerName = 71722552,
        Default = 1012917042,
        DefaultBrawlingStyle = 665939989,
        defaultEntitySets = 1407157833,
        DefaultGestureClipSet = 289586118,
        DefaultRemoveRangeMultiplier = 2267082285,
        DefaultSpawningPreference = 3497281775,
        DefaultTaskDataSetName = 2977281996,
        DefaultUnarmedWeapon = 2801601573,
        DefaultVisemeClipSet = 3269491505,
        DelayDoorClosingForPlayer = 2356415658,
        Density = 1026783212,
        DensityRange = 4153067752,
        directedLifeTime = 2075377911,
        directedWidth = 932713096,
        direction = 887068712,
        Direction = 2690021765,
        disableBonnetCamera = 1563940027,
        disabled = 2572083169,
        Disabled = 295298378,
        disabledFiles = 3110537950,
        Dispatch = 3591134869,
        Distance = 1974652584,
        DistanceRange = 1987085678,
        DISTANT_LIGHTS_FILE = 983558349,
        DISTANT_LIGHTS_HD_FILE = 2925996279,
        distBetweenCoronas = 1962520137,
        distBetweenCoronas_far = 232750087,
        DLC_ITYP_REQUEST = 4114167230,
        DLC_SCRIPT_METAFILE = 259967989,
        DLC_WEAPON_PICKUPS = 3168769355,
        dlcName = 2337697442,
        DontCloseWhenTouched = 1465449817,
        door_dside_f = 1744947660,
        door_dside_r = 3782851822,
        door_pside_f = 2553297679,
        door_pside_r = 1096977781,
        DOOR_TUNING_FILE = 57918953,
        drawableDictionary = 4229936891,
        DrawableId = 1166348048,
        DrawableIndex = 1740452767,
        DSP_NORMAL = 1082005734,
        duration = 3674968789,
        Duration = 2193831214,
        Edges = 1456031062,
        effectsData = 3285521232,
        emmissiveBoost = 1697573984,
        EMPTY = 2749884260,
        Enable = 421699355,
        enabled = 1527945487,
        Enabled = 1989893331,
        EnabledByDefault = 3921215899,
        end = 2965669335,
        End = 443072552,
        endHour = 380604338,
        EndModel = 3041118144,
        endPhase = 1600588195,
        endRadius = 306326438,
        enforceLsnSorting = 3949387622,
        engineblock = 2036489924,
        engineDamagePtFxEnabled = 2314702693,
        engineDamagePtFxHasPanel = 811799967,
        engineDamagePtFxHasRotorEvo = 935734665,
        engineDamagePtFxNoPanelName = 2142304406,
        engineDamagePtFxPanelOpenName = 2589870806,
        engineDamagePtFxPanelShutName = 2754603386,
        engineDamagePtFxRange = 1633907331,
        engineDamagePtFxSpeedEvoMax = 4116298751,
        engineDamagePtFxSpeedEvoMin = 1190778122,
        engineStartupPtFxEnabled = 2837195620,
        engineStartupPtFxName = 2081216567,
        engineStartupPtFxRange = 3534688011,
        entities = 3433796359,
        ENTITYFX_FILE = 209619560,
        EventType = 2248400140,
        exclusions = 1912839368,
        executionConditions = 312713139,
        exhaust = 2148626005,
        exhaust_2 = 3047243728,
        exhaust_3 = 4276408918,
        exhaust_4 = 286750395,
        exhaustPtFxCutOffSpeed = 1411922576,
        exhaustPtFxEnabled = 3040982233,
        exhaustPtFxName = 2262693655,
        exhaustPtFxRange = 3636073,
        exhaustPtFxScale = 4006380515,
        exhaustPtFxSpeedEvoMax = 1132138093,
        exhaustPtFxSpeedEvoMin = 2787040150,
        exhaustPtFxTempEvoMax = 2189200497,
        exhaustPtFxTempEvoMin = 2162145396,
        exhaustPtFxThrottleEvoOnGearChange = 1254006862,
        explodeAttachEntityWhenFinished = 2712903420,
        Explosion = 3638218222,
        EXPLOSION_INFO_FILE = 1307223293,
        EXPLOSIONFX_FILE = 2522650906,
        ExpressionDictionaryName = 1760551351,
        expressionName = 1573835099,
        ExpressionName = 3005293958,
        ExpressionSetName = 2352891724,
        extendedRange = 3534580187,
        extensions = 4051599144,
        ExternallyDrivenDOFs = 4106672091,
        extra_1 = 3819846466,
        extra_2 = 3050790801,
        extra_3 = 2297431491,
        extra_4 = 2590320813,
        extra_5 = 2830583129,
        EXTRA_FOLDER_MOUNT_DATA = 374419551,
        EXTRA_TITLE_UPDATE_DATA = 2227896657,
        FacialClipsetGroupName = 1843847949,
        fallbackId = 3378470045,
        Falling = 4171606781,
        falloff = 3429369576,
        falloffExponent = 733168314,
        falloffMax = 2603992812,
        Female = 107208361,
        FFrontOffset = 2475984948,
        Fight = 2236152585,
        filename = 1087019066,
        filesToDisable = 3328021166,
        filesToEnable = 2417471446,
        filesToInvalidate = 3805669424,
        fileType = 345145806,
        FIREFX_FILE = 1731707109,
        FirstPersonDriveByIKOffset = 1272308759,
        flags = 1741842546,
        Flags = 1264718594,
        flash = 2239439183,
        Flee = 1684954205,
        forceFactor = 3761213775,
        Forward = 4076313930,
        Fov = 3926516228,
        fragDamage = 2676323813,
        fRagdollForceModifier = 1451234527,
        frontIndicatorCorona = 3430197797,
        fSelfForceModifier = 3267483248,
        FullBodyDamageClipSet = 4228310587,
        FUpOffset = 4137555685,
        fwClipItem = 4225016529,
        fwClipItemWithProps = 615994212,
        fwClipSet = 3765269019,
        fwClipSetManager = 4032904779,
        fxName = 1920790105,
        fxOffsetPos = 3676475576,
        fxOffsetRot = 1710928362,
        fxType = 529104057,
        GetupSetHash = 1726861708,
        GroundColor = 860002656,
        group = 3391120809,
        Group = 1713610519,
        Groups = 2500839488,
        GTXD_PARENTING_DATA = 2798946644,
        guid = 2591780461,
        HANDLING_FILE = 46800217,
        hash = 1048674328,
        HDDist = 4257505727,
        HDTxd = 1692217392,
        HDTxdBindingArray = 4153080611,
        Heading = 3903571810,
        HeadingLimits = 2310315578,
        headLight = 1105987835,
        headlight_l = 2403350912,
        headlight_r = 3886869072,
        headLightCorona = 1649539989,
        Height = 4052201683,
        HIGH_HEELS = 2100709655,
        highPri = 1331010150,
        HoldDuration = 2367844690,
        hub_lf = 3891344909,
        hub_rf = 2300894090,
        iCosZ = 3735431522,
        id = 459292749,
        Id = 3809113010,
        identifier = 4004242505,
        Idle = 923499413,
        IdleTransitionBlendOutTime = 61709549,
        IdleTransitions = 1687702635,
        ids = 4038920459,
        IgnoreMaxInRange = 3250311224,
        IgnoreOpenDoorTaskEdgeLerp = 975984281,
        IgnorePavementChecks = 1501464625,
        imapDependencies = 735712319,
        imapDependencies_2 = 3712769228,
        imapName = 833569695,
        IN_VEHICLE = 1015874207,
        includedDataFiles = 2354614069,
        includedXmlFiles = 3280956850,
        Index = 1035793140,
        indicator = 801150652,
        indicator_lf = 3403024362,
        indicator_rf = 2051585809,
        indices = 3921649453,
        Infos = 802810900,
        InitDatas = 1512338287,
        initSpeed = 3640438618,
        InjuredStrafeClipSet = 1464530836,
        innerConeAngle = 1245835442,
        installPartition = 3475002187,
        intensity = 4023228733,
        Intensity = 140854398,
        intensity_far = 3542645631,
        IntensityVar = 2813237244,
        interior = 560567274,
        INTERIOR_PROXY_ORDER_FILE = 821873185,
        InteriorNames = 2406565252,
        Interiors = 947288719,
        IPL_FILE = 2251386970,
        iRadius = 1998996693,
        IsHeadBlendPed = 591520311,
        iSinZ = 1351095745,
        IsStreamedGfx = 3353096503,
        Item = 104834034,
        itypDependencies_2 = 3529579673,
        iType = 3252237582,
        JUNCTION_TEMPLATES_FILE = 1075369871,
        JUNCTION_TEMPLATES_PSO_FILE = 1684997832,
        kBoth = 1849703770,
        Key = 1620616462,
        KilledPerceptionRangeModifer = 2618596152,
        kitName = 1513897539,
        kits = 1843360923,
        Kits = 1497090499,
        kitType = 3008983707,
        leakPtFxEnabled = 1064432315,
        leakPtFxOilName = 729665807,
        leakPtFxPetrolName = 3533268990,
        leakPtFxRange = 2910098562,
        leakPtFxSpeedEvoMax = 1705315422,
        leakPtFxSpeedEvoMin = 2575887885,
        length = 2508072249,
        LifeTime = 4209357938,
        Lights = 2854514190,
        lightSettings = 2377329928,
        limitAngle = 2100360280,
        linkedModels = 3815104759,
        linkMods = 769154353,
        LIQUIDFX_FILE = 1699106320,
        liveries = 2791605300,
        livery = 2153615120,
        liveryNames = 1704397081,
        loadCompletely = 713423689,
        LoadOut = 4277349827,
        LOADOUTS_FILE = 808720620,
        locations = 3724288529,
        locked = 2448219441,
        lodDist = 3212107687,
        lodLevel = 1821316885,
        LODTYPES_DEPTH_HD = 3259521980,
        LODTYPES_DEPTH_LOD = 2384644182,
        LODTYPES_DEPTH_SLOD1 = 2554074988,
        LODTYPES_DEPTH_SLOD2 = 315427988,
        LODTYPES_DEPTH_SLOD3 = 2164549889,
        LODTYPES_DEPTH_SLOD4 = 1868383667,
        LODTYPES_DEPTH_ORPHANHD = 2106806081,
        mapChangeSetData = 815157305,
        MapDataGroups = 3039604259,
        MAPZONES_FILE = 2154214988,
        maskID = 2432235300,
        MassMultiplier = 1613940114,
        MATERIALFX_FILE = 905909785,
        max = 1616931012,
        Max = 344563784,
        MaxDistance = 2770481267,
        MaxPassengersInCar = 1694835331,
        MaxScale = 4214801493,
        MaxScaleZ = 1351348251,
        MaxSpeed = 3972966657,
        MaxTime = 786767296,
        MaxTintPalette = 3492298933,
        MaxXRotation = 658255980,
        MaxYRotation = 2609605325,
        MaxZOffset = 1569839200,
        MaxZRotation = 3093288384,
        memoryGroup = 1079355696,
        MicroMovementsFreqH = 215094271,
        MicroMovementsFreqV = 1945002622,
        MicroMovementsScaleH = 2532792329,
        MicroMovementsScaleV = 2313960935,
        min = 4264617715,
        Min = 3358645132,
        MinActivationImpulse = 1033747207,
        MinDistance = 1316787168,
        minorExplosion = 3090421228,
        MinScale = 2118753352,
        MinScaleZ = 572504281,
        MinTime = 614798748,
        MinTintPalette = 2179154468,
        MinXRotation = 3795236509,
        MinYRotation = 2447817968,
        MinZOffset = 1998724326,
        MinZRotation = 2511320236,
        mirrorTexture = 1892759569,
        misc_a = 2172915033,
        misc_b = 2948983260,
        misc_c = 3705750550,
        misc_d = 2334728355,
        misc_e = 3629890315,
        misc_f = 4003129225,
        misc_g = 867496380,
        misc_h = 702996000,
        misc_i = 2672412968,
        misc_j = 2246219354,
        misc_k = 986218535,
        misc_l = 1360178363,
        misc_m = 4199644986,
        misc_n = 3363543951,
        misc_o = 2517907133,
        misc_p = 3821556264,
        misc_q = 101324459,
        misc_r = 332902982,
        misc_s = 3515428266,
        misc_t = 526666079,
        misc_u = 1020363837,
        misc_v = 1257971856,
        misc_w = 1686098841,
        misc_x = 2041970181,
        misc_y = 1413133063,
        misc_z = 2850643555,
        misfirePtFxEnabled = 2760245605,
        misfirePtFxName = 4265177602,
        misfirePtFxRange = 3937313011,
        MKT_SPECIAL = 2316627489,
        MKT_SPORT = 3608585597,
        MKT_STANDARD = 315733923,
        MKT_SUV = 2385734984,
        MLOInstflags = 3761966250,
        mod_col_1 = 1338030889,
        mod_col_2 = 2758960267,
        mod_col_3 = 1785032818,
        mod_col_4 = 1092558310,
        mod_col_5 = 119450078,
        ModelId = 2410101093,
        modelName = 194221603,
        ModelName = 4216861609,
        ModelSet = 1518141539,
        ModelToTuneMapping = 1001913906,
        modifier = 1699237703,
        modShopLabel = 4132169566,
        MotionTaskDataSetName = 1092878940,
        Move = 528166787,
        MOVE_NETWORK_DEFS = 4182086555,
        MoveBlendRatio = 778269991,
        MovementClipSet = 3248325447,
        MovementClipSetId = 549835433,
        MovementModes = 2739474645,
        MovementModeUnholsterData = 523961350,
        MovementToStrafeClipSet = 4177809469,
        moveNetworkFlags = 4273852377,
        MP_STATS_DISPLAY_LIST_FILE = 759160086,
        MP_STATS_UI_LIST_FILE = 2486889377,
        mtlBangPtFxVehicleEvo = 1188575673,
        mtlBangPtFxVehicleScale = 2772539357,
        mtlScrapePtFxVehicleEvo = 1379406366,
        mtlScrapePtFxVehicleScale = 3990432188,
        multiples = 1309656778,
        multiTxdRelationships = 3649984070,
        MustUse = 331851963,
        name = 3873537812,
        Name = 2901156542,
        NamedTuningArray = 2148169260,
        NavCapabilitiesName = 3282019215,
        NAVMESH_INDEXREMAPPING_FILE = 1431019085,
        NAVNODE_INDEXREMAPPING_FILE = 2576484635,
        networkPedModifier = 2824520073,
        networkPlayerModifier = 3578474195,
        Nodes = 804169170,
        none = 493038497,
        None = 1640121937,
        normal = 1330140418,
        Normal = 3599348095,
        NormalMapName = 2845714814,
        NUM_ANCHORS = 665640573,
        numCoronas = 2225470999,
        numExitPortals = 528711607,
        OBJ_COVER_TUNING_FILE = 628815953,
        offset = 2705095151,
        offsetPosition = 3633645315,
        offsetRotation = 1389511464,
        ON_FOOT = 2976953365,
        opacity = 3644411688,
        outerConeAngle = 4179134239,
        overlay = 943450718,
        OVERLAY_INFO_FILE = 3489350694,
        overturnedSmokePtFxAngleThresh = 2735995463,
        overturnedSmokePtFxEnabled = 1633606873,
        overturnedSmokePtFxEngineHealthThresh = 132281413,
        overturnedSmokePtFxName = 1978623397,
        overturnedSmokePtFxRange = 1730945222,
        overturnedSmokePtFxSpeedThresh = 2304473042,
        owner = 2349203824,
        OwnerName = 1481791743,
        Pad = 1592782806,
        parent = 2845591121,
        parentIndex = 3633459645,
        parentName = 2521104825,
        PARTITION_0 = 1376468858,
        PARTITION_1 = 2621625320,
        PARTITION_2 = 2912515733,
        patchFiles = 3524138408,
        PATH_ZONES_FILE = 884764256,
        PED_DAMAGE_APPEND_FILE = 3868325674,
        PED_FIRST_PERSON_ALTERNATE_DATA = 143306029,
        PED_FIRST_PERSON_ASSET_DATA = 348738744,
        PED_METADATA_FILE = 3698391097,
        PED_OVERLAY_FILE = 1407571174,
        PED_PERSONALITY_FILE = 469479865,
        PedCapsuleName = 3605846536,
        pedCompExpressionIndex = 656720598,
        pedCompExpressions = 4168161021,
        pedcompID = 3512253528,
        pedCompID = 3337196122,
        PedComponentClothName = 2679581144,
        PedComponentSetName = 3295015867,
        pedCompVarIndex = 2890646891,
        PedIKSettingsName = 851100275,
        PedLayoutName = 704782517,
        PedPersonalities = 2345512339,
        pedPropExpressionIndex = 3269764788,
        pedPropExpressions = 1538058350,
        pedPropID = 1389713939,
        pedPropVarIndex = 461768873,
        Peds = 4047618778,
        PedScale = 3537940146,
        PEDSTREAM_FILE = 1358252642,
        pedType = 2747160189,
        Pedtype = 3052355362,
        PedVoiceGroup = 1999554162,
        percentage = 2947557653,
        PerceptionInfo = 3174726878,
        PERMANENT_ITYP_FILE = 2437884080,
        persistent = 4183121383,
        Personality = 620072928,
        petrolTankFirePtFxName = 2162940361,
        petrolTankFirePtFxRadius = 2461827139,
        petrolTankFirePtFxRange = 165484253,
        petrolTankFirePtFxSpeedEvoMax = 2172227529,
        petrolTankFirePtFxSpeedEvoMin = 1276446821,
        Pistol = 805949221,
        Pitch = 4037952930,
        PitchChangeRate = 1754758744,
        PitchLimits = 1158567006,
        PitchOffset = 3015997841,
        PLANE = 2676158011,
        planeAfterburnerPtFxEnabled = 3213641538,
        planeAfterburnerPtFxName = 446218229,
        planeAfterburnerPtFxRange = 408793866,
        planeAfterburnerPtFxScale = 2145730461,
        planeDamageFirePtFxEnabled = 3414165598,
        planeDamageFirePtFxName = 1338161444,
        planeDamageFirePtFxRange = 2839206294,
        planeDamageFirePtFxSpeedEvoMax = 571971263,
        planeDamageFirePtFxSpeedEvoMin = 1883098650,
        planeGroundDisturbPtFxDist = 4253009632,
        planeGroundDisturbPtFxEnabled = 3844975759,
        planeGroundDisturbPtFxNameDefault = 648304806,
        planeGroundDisturbPtFxNameDirt = 1349328259,
        planeGroundDisturbPtFxNameFoliage = 3426743478,
        planeGroundDisturbPtFxNameSand = 3528449028,
        planeGroundDisturbPtFxNameWater = 253287460,
        planeGroundDisturbPtFxRange = 2117069571,
        planeGroundDisturbPtFxSpeedEvoMax = 1904205977,
        planeGroundDisturbPtFxSpeedEvoMin = 3750053303,
        planeWingTipPtFxEnabled = 630564551,
        planeWingTipPtFxName = 1116747820,
        planeWingTipPtFxRange = 2911605361,
        planeWingTipPtFxSpeedEvoMax = 1891037280,
        planeWingTipPtFxSpeedEvoMin = 432519559,
        plantInfos = 1195126367,
        PlantTag = 1119170566,
        plateProbabilities = 759151167,
        Player = 2751443189,
        POPGRP_FILE = 2708681290,
        POPSCHED_FILE = 3496245090,
        PoseMatcherName = 407450340,
        PoseMatcherProneName = 1468409568,
        position = 18243940,
        Position = 210930065,
        PositionOffset = 3553152178,
        posn = 967189988,
        PovCameraOffset = 3390378580,
        PreciseUseTime = 196435285,
        priority = 342945216,
        Priority = 2673351645,
        Probabilities = 4251991726,
        probability = 3698534260,
        PROC_META_FILE = 3342716104,
        PROCOBJ_ALIGN_OBJ = 2620161998,
        PROCOBJ_CAST_SHADOW = 1528296021,
        PROCOBJ_FILE = 1526130529,
        PROCOBJ_IS_FLOATING = 3217678483,
        PROCOBJ_NETWORK_GAME = 390676221,
        PROCOBJ_USE_SEED = 2229775436,
        procObjInfos = 4262901725,
        PROCPLANT_CAMERADONOTCULL = 1147935867,
        PROCPLANT_FURGRASS = 3729666926,
        PROCPLANT_GROUNDSCALE1VERT = 389823981,
        PROCPLANT_LOD0 = 1994951555,
        PROCPLANT_LOD1 = 4009819058,
        PROCPLANT_LOD2 = 72099408,
        PROCPLANT_NOGROUNDSKEW_LOD0 = 398505754,
        PROCPLANT_NOGROUNDSKEW_LOD1 = 3381598904,
        PROCPLANT_NOGROUNDSKEW_LOD2 = 885125404,
        PROCPLANT_NOSHADOW = 696619156,
        PROCPLANT_UNDERWATER = 882615863,
        procTagTable = 2377507684,
        PropRestrictions = 465162194,
        props = 2287400538,
        PropsName = 1179225812,
        ptfxAssetDependencyInfos = 493695515,
        PTFXASSETINFO_FILE = 1772520447,
        ptFxHasTint = 3576542357,
        ptFxIsTriggered = 3434402314,
        ptFxName = 1203215085,
        ptFxProbability = 3448174308,
        ptFxScale = 1567144545,
        ptFxSize = 1080281337,
        ptFxSpeedEvoMax = 320256667,
        ptFxSpeedEvoMin = 3884276349,
        ptFxTag = 2524903540,
        ptFxTintB = 2225110962,
        ptFxTintG = 23853287,
        ptFxTintR = 1304072655,
        pull = 350772507,
        pullCoronaIn = 538460876,
        PV_COMP_INVALID = 476847607,
        PV_COMP_ACCS = 3760011790,
        PV_COMP_BERD = 696691459,
        PV_COMP_DECL = 3631275576,
        PV_COMP_FEET = 2300506577,
        PV_COMP_HAIR = 2918472950,
        PV_COMP_HAND = 2793296290,
        PV_COMP_HEAD = 1159394596,
        PV_COMP_JBIB = 2376289126,
        PV_COMP_LOWR = 3254995156,
        PV_COMP_MAX = 920969818,
        PV_COMP_TASK = 1051671594,
        PV_COMP_TEEF = 1520752005,
        PV_COMP_UPPR = 3707586858,
        RADIO_GENRE_CLASSIC_ROCK = 567874491,
        RADIO_GENRE_JAZZ = 3210576665,
        RADIO_GENRE_MEXICAN = 4058039902,
        RADIO_GENRE_MODERN_ROCK = 4200371511,
        RADIO_GENRE_MOTOWN = 1526192047,
        RADIO_GENRE_OFF = 3820886398,
        RADIO_GENRE_PUNK = 2352668725,
        RADIO_GENRE_REGGAE = 2059985335,
        RADIO_GENRE_RIGHT_WING_TALK = 1758684295,
        RADIO_GENRE_SURF = 2495475670,
        Radio1 = 3430266395,
        Radio2 = 3132297878,
        radius = 1337695475,
        Radius = 3144350114,
        RadiusScale = 3245550474,
        rage__fwInstancedMapData = 4048164286,
        rage__phVerletClothCustomBounds = 847348117,
        rage__spdGrid2D = 2599150383,
        range = 332484516,
        Rate = 2986741774,
        rear = 2243100542,
        rearIndicatorCorona = 103408473,
        RegionDefs = 3713107563,
        RelationshipGroup = 4150596315,
        requiredImap = 2090738474,
        requiresLoadingScreen = 3135083525,
        ResetNoCollisionOnCleanUp = 3362749677,
        residentAnims = 2052114030,
        residentResources = 82002169,
        residentTxd = 1079754329,
        Restriction = 26114980,
        reversingLight = 242592930,
        reversingLightCorona = 3960865135,
        RFrontOffset = 1353482245,
        RGBI = 194542898,
        Rifle = 3187352598,
        rimRadius = 1671388815,
        Roll = 2579823494,
        rooms = 3441481640,
        rotate = 3903098393,
        rotation = 2010988560,
        Rotation = 2371198895,
        RotationLimitAngle = 648763416,
        RPF_FILE = 81740897,
        RPF_FILE_PRE_INSTALL = 31119764,
        RumbleDuration = 79170607,
        RUpOffset = 3943427752,
        SAT_NONE = 836773056,
        SCALEFORM_DLC_FILE = 258049916,
        ScaleRange = 2691059430,
        ScaleRangeXYZ = 4267248400,
        ScaleRangeZ = 2934008023,
        ScaleVariationXY = 754964759,
        ScaleVariationZ = 2602640464,
        ScaleXY = 3128382556,
        ScaleZ = 712150328,
        SCENARIO_INFO_FILE = 2244432863,
        SCENARIO_POINTS_PSO_FILE = 1653171061,
        SCENARIO_POP_STREAMING_NORMAL = 79175210,
        ScenarioPoints = 3966518334,
        ScenarioPopStreamingSlot = 3440415111,
        ScenarioType = 191322199,
        SCRIPTFX_FILE = 3176550718,
        SeatIndex = 2604655109,
        Seats = 368310011,
        sets = 4021164785,
        Sets = 778639775,
        settings = 2768156407,
        Settings = 1654011315,
        Sexiness = 867165133,
        SF_HOT_PERSON = 3612284555,
        SF_JEER_AT_HOT_PED = 213733388,
        shaderVariableComponents = 3687287113,
        shaderVariableHashString = 490746723,
        shadowBlur = 3672716153,
        shockingEventAudioRangeOverride = 345540543,
        shockingEventVisualRangeOverride = 2220221975,
        SHOP_PED_APPAREL_META_FILE = 4189023929,
        shortRange = 178074428,
        ShouldLatchShut = 1101824832,
        SidestepClipSet = 1255368790,
        sirenSettings = 2230033165,
        Situations = 2546696905,
        size = 3226656423,
        size_far = 388176731,
        sLevelData = 4248020339,
        SLOD_HUMAN = 2092589681,
        slot = 933689839,
        slotNames = 2198312216,
        SLOWNESS_ZONES_FILE = 819490736,
        Sniper = 3200555378,
        SP_Low = 1535176458,
        SP_Medium = 1318432000,
        SP_MULTIPLAYER_RESIDENT = 330835765,
        SP_SINGLEPLAYER_RESIDENT = 2843514243,
        SP_STATS_DISPLAY_LIST_FILE = 957687860,
        SP_STATS_UI_LIST_FILE = 3848387179,
        SP_STREAMING = 1647646833,
        spacing = 370899326,
        Spacing = 1644991037,
        spawnType = 4261247615,
        specialAttribute = 1813324772,
        speed = 4187447851,
        sphere = 953812642,
        Spheres = 3873229047,
        splashInPtFxEnabled = 2568271272,
        splashInPtFxName = 1671048614,
        splashInPtFxRange = 424335064,
        splashInPtFxSizeEvoMax = 2546557251,
        splashInPtFxSpeedDownwardEvoMax = 2719708920,
        splashInPtFxSpeedDownwardEvoMin = 1110754284,
        splashInPtFxSpeedDownwardThresh = 2861864958,
        splashInPtFxSpeedLateralEvoMax = 717627197,
        splashInPtFxSpeedLateralEvoMin = 1180941296,
        splashOutPtFxEnabled = 265145855,
        splashOutPtFxName = 2228265562,
        splashOutPtFxRange = 2084717992,
        splashOutPtFxSizeEvoMax = 2926629502,
        splashOutPtFxSpeedLateralEvoMax = 4269956697,
        splashOutPtFxSpeedLateralEvoMin = 976640088,
        splashOutPtFxSpeedUpwardEvoMax = 2874671957,
        splashOutPtFxSpeedUpwardEvoMin = 340254431,
        splashTrailPtFxEnabled = 1540336092,
        splashTrailPtFxName = 3437892535,
        splashTrailPtFxRange = 496141127,
        splashTrailPtFxSizeEvoMax = 2112168390,
        splashTrailPtFxSpeedEvoMax = 1320429615,
        splashTrailPtFxSpeedEvoMin = 465674370,
        splashWadePtFxEnabled = 3946923366,
        splashWadePtFxName = 573019250,
        splashWadePtFxRange = 2801117501,
        splashWadePtFxSizeEvoMax = 230363215,
        splashWadePtFxSpeedRiverEvoMax = 3237227592,
        splashWadePtFxSpeedRiverEvoMin = 1052618905,
        splashWadePtFxSpeedVehicleEvoMax = 1036775998,
        splashWadePtFxSpeedVehicleEvoMin = 1176468081,
        sStatsMetadataTuning = 3459433883,
        StaggerFall = 2002487478,
        Standard = 2352402326,
        start = 2229020447,
        Start = 3073138309,
        startHour = 625204231,
        StartModel = 226559569,
        startPhase = 3221846423,
        StationaryReactions = 2620629637,
        statMods = 216311195,
        STATS_METADATA_PSO_FILE = 1289107292,
        StdDoorOpenBothDir = 1469697918,
        StdDoorOpenNegDir = 2656051665,
        StdDoorRotDir = 1083750337,
        steeringwheel = 1325046900,
        Stiffness = 294387850,
        StillToSitPedalGearApproachRate = 2386385168,
        StrafeClipSet = 1514292895,
        STREAMING_REQUEST_LISTS_FILE = 2865461394,
        streamingPolicy = 827725946,
        streamingPriority = 3660169125,
        STREET_VEHICLE_ASSOCIATION_FILE = 3243535945,
        strength = 4280043047,
        Stubble = 2766015245,
        SuperlodType = 868617040,
        Tag = 2215212623,
        tailLight = 1210163367,
        tailLightCorona = 4104001094,
        tailLightMiddleCorona = 3579298804,
        tangent = 2389642153,
        Target = 3866136337,
        targetAsset = 662555360,
        TargetingThreatModifier = 41162556,
        TargetOffset = 2175492938,
        TargetRadius = 1146856098,
        TaskDataName = 653610287,
        TATTOO_SHOP_DLC_FILE = 1223910633,
        TB_WARM = 1158270414,
        TechSavvy = 248494816,
        Teeter = 3508388318,
        template = 3202639186,
        texId = 1785432003,
        TEXTFILE_METAFILE = 1142425891,
        textureDictionary = 1976702369,
        TextureId = 3617584144,
        textureName = 440050042,
        ThermalBehaviour = 3253990041,
        time = 258444835,
        TIME_FILE = 1428695449,
        TIMECYCLE_FILE = 755616351,
        TIMECYCLEMOD_FILE = 2793750187,
        timeCycleModifiers = 2946251737,
        timeTillPedLeaves = 213640539,
        top = 1281216666,
        TorqueAngularVelocityLimit = 3539021765,
        tracks = 794089857,
        TRAILER = 4229025179,
        TRAINCONFIGS_FILE = 751887759,
        TRAINTRACK_FILE = 680882864,
        TriggerBoxMinMax = 2642293346,
        TS_LOW = 4290350623,
        Tunables = 508571515,
        Tuning = 2317966594,
        TuningName = 2921576840,
        Turn = 3647068299,
        turnOffBones = 3764022105,
        turnOffExtra = 2892421376,
        txdRelationships = 110813075,
        txdToLoad = 465628444,
        txdToUnload = 2372422677,
        type = 828747869,
        types = 138573281,
        UnholsterClipData = 1235872865,
        UnholsterClips = 3511043731,
        UnholsterClipSetId = 3278048392,
        unregisterResources = 910312539,
        Update = 575805931,
        UpperBodyFeatheredLeanEnabled = 2028170470,
        UpperBodyShadowExpressionEnabled = 1264317859,
        UseAutoOpenTriggerBox = 4151971060,
        UseLeftHandIk = 1829639529,
        UseWeaponAnimsForGrip = 1775814871,
        Value = 4108660753,
        variationData = 3467549031,
        Variations = 1085728185,
        VEHGEN_MARKUP_FILE = 2433209284,
        VEHICLE_LAYOUTS_FILE = 2004032454,
        VEHICLE_METADATA_FILE = 4125139733,
        VEHICLE_POPULATION_FILE = 4010054647,
        VEHICLE_RESPONSE_ARMY_BASE = 317362887,
        VEHICLE_RESPONSE_COUNTRYSIDE = 2467847847,
        VEHICLE_SHOP_DLC_FILE = 3203173146,
        VEHICLE_VARIATION_FILE = 4226342447,
        VEHICLEEXTRAS_FILE = 2814482675,
        VehicleScale = 201238485,
        Velocity = 3642784282,
        version = 1757576755,
        VersionNumber = 1292187579,
        verts = 120498671,
        VFX_SETTINGS_FILE = 1765838387,
        VFXFOGVOLUMEINFO_FILE = 895306,
        VfxInfoName = 3527474215,
        VFXINTERIORINFO_FILE = 354822867,
        VFXPEDINFO_FILE = 962370952,
        VFXREGIONINFO_FILE = 3633596549,
        vfxTagHashName = 1944993828,
        VFXVEHICLEINFO_FILE = 1918258814,
        vfxVehicleInfos = 1829968483,
        VFXWEAPONINFO_FILE = 1215743990,
        visibleMods = 33867712,
        //vlink87812 = 380604338,
        VMCP_DEFAULT = 1688385326,
        VMT_ARMOUR = 2031251422,
        VMT_BONNET = 1157831199,
        VMT_BRAKES = 2354237771,
        VMT_BUMPER_F = 3594621894,
        VMT_BUMPER_R = 2063293755,
        VMT_CHASSIS = 2275972991,
        VMT_CHASSIS2 = 2944517492,
        VMT_CHASSIS3 = 2694326177,
        VMT_CHASSIS4 = 2463042575,
        VMT_CHASSIS5 = 2742201586,
        VMT_DOOR_L = 3833672138,
        VMT_ENGINE = 154537048,
        VMT_ENGINEBAY1 = 3358404671,
        VMT_ENGINEBAY2 = 4274232691,
        VMT_ENGINEBAY3 = 3976067552,
        VMT_EXHAUST = 610039613,
        VMT_GEARBOX = 2500094337,
        VMT_GRILL = 2021558782,
        VMT_HORN = 100765382,
        VMT_HYDRO = 1330081664,
        VMT_ICE = 2442467387,
        VMT_INTERIOR1 = 4022516897,
        VMT_INTERIOR2 = 1135961221,
        VMT_INTERIOR3 = 829865992,
        VMT_INTERIOR4 = 675392926,
        VMT_INTERIOR5 = 368838931,
        VMT_KNOB = 676118374,
        VMT_LIVERY_MOD = 2724696322,
        VMT_PLAQUE = 671395830,
        VMT_PLTHOLDER = 1090914661,
        VMT_PLTVANITY = 1166632877,
        VMT_ROOF = 908701629,
        VMT_SEATS = 4033680966,
        VMT_SKIRT = 380480791,
        VMT_SPOILER = 1049675683,
        VMT_STEERING = 31361425,
        VMT_SUSPENSION = 3334458998,
        VMT_TRUNK = 514422827,
        VMT_WHEELS = 4228473823,
        VMT_WHEELS_REAR_OR_HYDRAULICS = 1919950653,
        VMT_WING_L = 3535906757,
        VMT_WING_R = 2323846985,
        vPos = 587040309,
        WantedLevel1 = 2416800515,
        WantedLevel2 = 1650825140,
        WantedLevel3 = 1939323416,
        WantedLevel4 = 1171840667,
        WantedLevel5 = 1195762037,
        WATER_FILE = 2413655090,
        Weak = 4041095418,
        WEAPON_ANIMATIONS_FILE = 3924289757,
        WEAPON_METADATA_FILE = 2179567645,
        WEAPON_SHOP_INFO_METADATA_FILE = 3762885521,
        WeaponAccuracy = 2027467678,
        WeaponAnimations = 4015456176,
        WeaponClipFilterId = 671807081,
        WeaponClipSetId = 2215753076,
        WEAPONCOMPONENTSINFO_FILE = 2246020636,
        WEAPONFX_FILE = 1805309100,
        WeaponImpulseMultiplier = 86352657,
        WEAPONINFO_FILE = 314037850,
        WEAPONINFO_FILE_PATCH = 4078051975,
        Weapons = 3632627376,
        WEATHER_FILE = 1275718771,
        WeatherTypes = 2541515394,
        weight = 2618193740,
        wheelBurnoutPtFxFricMult = 3985640029,
        wheelBurnoutPtFxTempMult = 4090549898,
        wheelBurstPtFxName = 2298765511,
        wheelBurstPtFxRange = 627010713,
        wheelDisplacementPtFxDispMult = 1903391014,
        wheelFirePtFxName = 1493987177,
        wheelFirePtFxRange = 2979062979,
        wheelFirePtFxSpeedEvoMax = 2074742492,
        wheelFirePtFxSpeedEvoMin = 88414520,
        wheelFrictionPtFxFricMult = 3344943153,
        WHEELFX_FILE = 797011099,
        wheelGenericDecalSet = 42119146,
        wheelGenericPtFxSet = 317708598,
        wheelGenericRangeMult = 3112058125,
        wheelLowLodPtFxScale = 3101484583,
        wheelName = 1946665057,
        wheelPuncturePtFxName = 3306375051,
        wheelPuncturePtFxRange = 1038999289,
        Wheels = 3527735923,
        wheelSkidmarkPressureMult = 3868991234,
        wheelSkidmarkRearOnly = 3924188767,
        wheelSkidmarkSlipMult = 1637659302,
        wheelVariation = 3934106566,
        Width = 2076102628,
        WindBendScale = 2639208686,
        WindBendVariation = 3427496475,
        window_lf = 4283577347,
        window_rf = 498851022,
        windowsWithExposedEdges = 2852673211,
        windscreen_r = 1088105007,
        wing_lf = 491509005,
        wing_rf = 3902761333,
        WORLD_HEIGHTMAP_FILE = 2667598674,
        WORLD_WATERHEIGHT_FILE = 2962141595,
        wreckedFire2OffsetPos = 3365413657,
        wreckedFire2PtFxDurationMax = 3958205758,
        wreckedFire2PtFxDurationMin = 934999495,
        wreckedFire2PtFxEnabled = 942100204,
        wreckedFire2PtFxName = 2665978636,
        wreckedFire2PtFxRadius = 1241381211,
        wreckedFire2UseOverheatBone = 1005799487,
        wreckedFire3OffsetPos = 1884074151,
        wreckedFire3PtFxDurationMax = 3291844506,
        wreckedFire3PtFxDurationMin = 2778506827,
        wreckedFire3PtFxEnabled = 1459332728,
        wreckedFire3PtFxName = 4213089658,
        wreckedFire3PtFxRadius = 19666915,
        wreckedFire3UseOverheatBone = 3745878980,
        wreckedFirePtFxDurationMax = 912287935,
        wreckedFirePtFxDurationMin = 1608647578,
        wreckedFirePtFxEnabled = 1538181140,
        wreckedFirePtFxName = 4220065034,
        wreckedFirePtFxRadius = 1064003341,
        x = 2466489829,
        X = 1252398387,
        xRotation = 712901235,
        y = 2157248776,
        Y = 953119110,
        yRotation = 3411163434,
        z = 3059772574,
        Z = 1848695880,
        zBias = 4001151357,
        ZONEBIND_FILE = 3024721823,
        zRotation = 1366235387,



































        //Shader params - strings converted to lowercase before hashing!


        _dimensionLOD2 = 2213330743,
        _fakedGrassNormal = 3847734030,
        _vecCollParams = 1235110448,
        _vecVehColl0B = 3443329873,
        _vecVehColl0M = 2054776271,
        _vecVehColl0R = 3676612388,
        _vecVehColl1B = 3338172776,
        _vecVehColl1M = 3731892311,
        _vecVehColl1R = 1839679119,
        _vecVehColl2B = 1542889970,
        _vecVehColl2M = 298913216,
        _vecVehColl2R = 3503557575,
        _vecVehColl3B = 2492173731,
        _vecVehColl3M = 2003587933,
        _vecVehColl3R = 3129694622,
        _vecVehCollB = 4034110113,
        _vecVehCollM = 4084115603,
        _vecVehCollR = 2902956998,
        Acceleration_Delta = 4042077187,
        accumulationBufferSampler0 = 8230410,
        accumulationBufferSampler1 = 272905623,
        activeShadowCascades = 2747556057,
        adapDOFProj = 711499858,
        AdapLumSampler = 2600073949,
        AdaptedLumMax = 735476279,
        AdaptedLumMin = 120989687,
        AdaptionParams = 994945211,
        adaptive = 2577319765,
        AdaptiveDofDepthDownSampleParams = 530741887,
        adaptiveDOFExposureSampler = 2063861440,
        AdaptiveDofFocusDistanceDampingParams1 = 4192702981,
        AdaptiveDofFocusDistanceDampingParams2 = 3918393682,
        AdaptiveDOFOutputBuffer = 2655767810,
        AdaptiveDofParams0 = 1088399132,
        AdaptiveDofParams1 = 806028659,
        AdaptiveDofParams2 = 1767143429,
        AdaptiveDofParams3 = 2870836122,
        AdaptiveDOFParamsBuffer = 209455569,
        adaptiveDOFSampler = 2098736783,
        adaptiveDOFSamplerDepth = 718794333,
        AdaptTime = 1514540018,
        AirResist = 1208302886,
        alphaAdjust = 1287606900,
        AlphaMaskMapSampler = 1705051233,
        AlphaRange = 1331056747,
        AlphaScale = 931055822,
        AlphaTest = 950204405,
        alphaTestValue = 3310830370,
        altRemap = 285573515,
        AmbientDecalMask = 3686186843,
        AmbientLightingParams = 1614910597,
        ambientOcclusionContrast = 633061550,
        AmbientOccSampler = 1212577329,
        AnimatedNormalMapMask0Sampler = 2630205212,
        AnimatedNormalMapMask1Sampler = 1838164585,
        AnimatedNormalMapMask2Sampler = 2257753125,
        animatedNormalMapMod1 = 96407192,
        animatedNormalMapMod2 = 326478341,
        AnisoNoiseSpecSampler = 2134197289,
        AnisotropicAlphaBias = 363074471,
        anisotropicSpecularColour = 1673722929,
        anisotropicSpecularExponent = 499953092,
        anisotropicSpecularIntensity = 401654871,
        APlaneSampler = 1600333029,
        ApplyDamageSampler = 1117905904,
        approxTangent = 3606611481,
        ArmourStrength = 3061795481,
        AttenuationSampler = 483360323,
        AverageLuminanceOut = 1654447808,
        AvgLuminanceTexture = 1087818619,
        AzimuthColor = 360934156,
        AzimuthColorEast = 1882877478,
        azimuthEastColor = 1044876032,
        AzimuthHeight = 2649852765,
        AzimuthStrength = 2824307566,
        azimuthTransitionColor = 2670115477,
        azimuthTransitionPosition = 2764855899,
        azimuthWestColor = 1874413695,
        BackBufferSampler = 3700325701,
        BackBufferTexture = 3200056981,
        BaseSampler = 2669264211,
        baseTextureSampler = 1399472831,
        bDebugDisplayDamageMap = 727005071,
        bDebugDisplayDamageScale = 1720897181,
        Billboard = 552363713,
        blitSampler = 4098753311,
        BloodSampler = 1970149772,
        BloodSamplerVS = 3796090472,
        BloodZoneAdjust = 1011740581,
        bloomLum = 1959356754,
        BloomParams = 1213613006,
        BloomSampler = 1613750243,
        BloomSamplerG = 2187220839,
        BloomTexelSize = 3590118590,
        BlueOff = 1614062594,
        blurIntensity = 804387779,
        BlurSampler = 822703767,
        BlurVignettingParams = 871768731,
        BokehAlphaCutoff = 1703140281,
        BokehBrightnessParams = 1737665654,
        BokehEnableVar = 643379889,
        BokehGlobalAlpha = 1022881476,
        BokehNumAddedToBuckets = 2514924683,
        BokehParams1 = 3945388007,
        BokehParams2 = 4184896628,
        BokehPointBuffer = 2084769495,
        BokehSortedIndexBuffer = 1533187666,
        BokehSortedListBuffer = 201662228,
        BokehSortLevel = 2314931517,
        BokehSortLevelMask = 1605336858,
        BokehSortTransposeMatHeight = 3470273647,
        BokehSortTransposeMatWidth = 821002802,
        BokehSpritePointBuffer = 170997925,
        bottomSkyColour = 161676916,
        BoundRadius = 2230834649,
        branchBendPivot = 892666959,
        branchBendStiffnessAdjust = 3894262326,
        Brightness = 26603225,
        BrightnessSetting = 303513935,
        BrightTonemapParams0 = 118691255,
        BrightTonemapParams1 = 1904208559,
        BrokenBumpSampler = 2033191777,
        BrokenColor = 2817208061,
        BrokenDiffuseColor = 878330249,
        BrokenDiffuseSampler = 3349868497,
        BrokenGlassTileScale = 1356197901,
        BrokenSpecularColor = 1359397883,
        BrokenSpecularSampler = 3872409448,
        bumpiness = 4134611841,
        BumpSampler = 1186448975,
        BumpSampler_layer0 = 1073714531,
        BumpSampler_layer1 = 1422769919,
        BumpSampler_layer2 = 2745359528,
        BumpSampler_layer3 = 2975430677,
        BumpSampler_layer4 = 2417505683,
        BumpSampler_layer5 = 3720106230,
        BumpSampler_layer6 = 4091379000,
        BumpSampler2 = 1893875305,
        BumpSamplerFur = 2030333799,
        bumpSelfShadowAmount = 2907460320,
        BurnoutLimit = 2048742054,
        cBPlaneSampler = 1648690748,
        ChromAbParam = 2243268978,
        clearcol = 2021704599,
        clippingPlane = 1632555383,
        ClipPlanes = 4225498643,
        ClothDarken = 4285790447,
        ClothDarkenColor = 2192646550,
        clothParentMatrix = 2335024113,
        ClothSweatMapSampler = 1059055951,
        ClothSweatSpec = 2469844039,
        cloudBaseColour = 2670795993,
        cloudBaseMinusMidColour = 207551193,
        CloudBias = 1077109597,
        cloudBillboardParams = 1372983410,
        CloudColor = 3245908258,
        cloudConstants1 = 1542931277,
        cloudConstants2 = 1848698816,
        cloudConstants3 = 3972097247,
        cloudDetailConstants = 2178269534,
        CloudFadeOut = 1796923256,
        CloudInscatteringRange = 1590938598,
        cloudLayerAnimScale1 = 2699058131,
        cloudLayerAnimScale2 = 2904978527,
        cloudLayerAnimScale3 = 1697604722,
        cloudMidColour = 3120184161,
        cloudShadowColour = 2429466598,
        cloudShadowMinusBaseColourTimesShadowStrength = 3681751999,
        CloudShadowOffset = 1192276656,
        CloudShadowStrength = 3469302040,
        CloudThicknessEdgeSmoothDetailScaleStrength = 2448643918,
        CloudThreshold = 2011404587,
        ClumpBump = 620873514,
        COCOutputTexture = 561614071,
        ColorCorrect = 1418724964,
        ColorCorrectHighLum = 1002641818,
        ColorFringeParams1 = 1315010326,
        ColorFringeParams2 = 94922157,
        colorHighLum = 3178323397,
        colorLowLum = 4274011020,
        colorLum = 819694290,
        ColorSampler = 3918882525,
        colorScaler = 2433112487,
        ColorShift = 3269836664,
        ColorShiftLowLum = 2775271800,
        ColorShiftScalar = 2106064165,
        ColorTexture = 934209648,
        ComboHeightSamplerFur = 455740840,
        ComboHeightSamplerFur01 = 1709265783,
        ComboHeightSamplerFur2 = 374924583,
        ComboHeightSamplerFur23 = 2930074258,
        ComboHeightSamplerFur3 = 2760212866,
        ComboHeightSamplerFur4 = 4056161278,
        ComboHeightSamplerFur45 = 2509158229,
        ComboHeightSamplerFur67 = 1396547512,
        ComboHeightTexMask = 285679314,
        Contrast = 699508084,
        ConvertSampler = 4959160,
        CoronasDepthMapSampler = 3603235271,
        CrackDecalBumpAlphaThreshold = 3343925161,
        CrackDecalBumpAmount = 2155296103,
        CrackDecalBumpTileScale = 730767419,
        CrackEdgeBumpAmount = 3420190257,
        CrackEdgeBumpTileScale = 492538267,
        crackleIntensity = 1771354266,
        CrackleSampler = 1774790613,
        CrackMatrix = 2644409350,
        CrackOffset = 2214698276,
        CrackSampler = 3328498618,
        cRPlaneSampler = 3915834095,
        cubeFace = 2567801214,
        CurLumSampler = 3431586341,
        currentDOFTechnique = 3543504858,
        currentLum = 968818364,
        currentResolution = 4182813263,
        curveCoeffs = 2763646717,
        DamagedWheelOffsets = 1348413520,
        DamageMultiplier = 378227101,
        DamageSampler = 3579349756,
        damageSpecTextureSampler = 3820652825,
        DamageTextureOffset = 4318529,
        damageTextureSampler = 4132715990,
        DamageVertBuffer = 2811144871,
        DarkTonemapParams0 = 1554855265,
        DarkTonemapParams1 = 780523795,
        deathIntensity = 2219791851,
        DeathSampler = 4146990968,
        debugCloudsParams = 580885775,
        debugLightColour = 227690714,
        DecalSampler = 2811948736,
        DecalTint = 3092072610,
        DecorationFrameInfo = 3729783099,
        DecorationTattooAdjust = 1578586549,
        DecorationTintPaletteSel = 2448945809,
        DecorationTintPaletteTexSampler = 4286164294,
        deferredLightDownsampleDepthSampler = 110250107,
        deferredLightParams = 1690620309,
        deferredLightScreenSize = 3811483225,
        deferredLightVolumeParams = 2130744975,
        deferredPerspectiveShearParams0 = 3433855881,
        deferredPerspectiveShearParams1 = 61303170,
        deferredPerspectiveShearParams2 = 4125937165,
        deferredProjectionParams = 424764587,
        deferredVolumeColour = 2115695095,
        deferredVolumeDepthBufferSamp = 3381865158,
        deferredVolumeDirection = 3203966112,
        deferredVolumePosition = 1009422528,
        deferredVolumeShaftCompositeMtx = 3101393666,
        deferredVolumeShaftGradient = 404580226,
        deferredVolumeShaftGradientColourInv = 1067440921,
        deferredVolumeShaftPlanes = 3122758957,
        deferredVolumeTangentXAndShaftRadius = 1118228408,
        deferredVolumeTangentYAndShaftLength = 4283942594,
        DensitySampler = 3828368598,
        DepthBlurHalfResSampler = 2333753907,
        DepthBlurHalfResTexture = 2638246296,
        DepthBlurSampler = 979379647,
        DepthBlurTexture = 4038110621,
        depthBuffer = 3447665758,
        depthBuffer2 = 1908423578,
        depthBuffer2_Sampler = 720934291,
        DepthBufferSamp = 2492728818,
        DepthBufferSampler = 3497598060,
        DepthMapPointSampler = 4215380418,
        DepthMapSampler = 847477652,
        DepthMapTexSampler = 2784473838,
        DepthSampler = 383876435,
        depthSourceSampler = 2578937463,
        depthTexture = 4088842947,
        DepthTextureMS = 4134029566,
        deSatContrastGamma = 1070958827,
        Desaturate = 2639337807,
        desaturateTint = 2511699259,
        detailBumpiness = 1675037470,
        DetailBumpSampler = 143227613,
        DetailDensity2Sampler = 2587222892,
        DetailDensitySampler = 2270155403,
        detailMapOffset = 3032413960,
        DetailMapSampler = 1041827691,
        detailMapUScale = 489333004,
        detailMapVScale = 2830921123,
        DetailNormal2Sampler = 2004179855,
        DetailNormalSampler = 2903840997,
        DetailOffset = 2002782257,
        DetailSampler = 3393362404,
        detailSettings = 3038654095,
        detailUVScale = 3418497265,
        diffuse2SpecMod = 1788442252,
        diffuseCol = 1517692383,
        DiffuseExtraSampler = 58635929,
        DiffuseHfSampler = 2946270081,
        diffuseMod = 1685953011,
        DiffuseNoBorderTexSampler = 1732587965,
        DiffuseSampler = 4059966321,
        DiffuseSampler2 = 181641832,
        DiffuseSamplerFur = 1282320680,
        DiffuseSamplerPhase2 = 3227619449,
        DiffuseSamplerPoint = 4015001285,
        DiffuseSplatterTexSampler = 1412546033,
        DiffuseTexSampler = 3004704155,
        DiffuseTexSampler01 = 255045494,
        DiffuseTexSampler02 = 2707084226,
        DiffuseTexSampler03 = 2981196911,
        DiffuseTexSampler04 = 3291650421,
        DiffuseTexTileUV = 2816002123,
        DiffuseWoundTexSampler = 3758481220,
        DiffusionRadius = 4024070401,
        dimmerSet = 1523312743,
        dimmerSetPacked = 4182305072,
        DirectionalMotionBlurIterParams = 2777949533,
        DirectionalMotionBlurLength = 544111294,
        DirectionalMotionBlurParams = 3408424243,
        dirtColor = 1146381126,
        DirtDecalMask = 1050016400,
        dirtLevel = 47191856,
        dirtLevelMod = 3961814809,
        DirtSampler = 2124031998,
        DiskBrakeGlow = 1035405954,
        displParams = 1163050293,
        distanceMapSampler = 1616890976,
        DistEpsilonScaleMin = 1163639717,
        DistMapCenterVal = 1612602645,
        distortionParams = 2957679312,
        DistortionSampler = 342449994,
        ditherSampler = 612917610,
        dofBlur = 731686132,
        DofBlurWeight = 706444485,
        dofDist = 3329041621,
        dofInten = 3552457075,
        dofNoBlurBlendRingSize = 413916545,
        dofNoBlurRadius = 108398598,
        DOFOutputTexture = 3487236658,
        dofProj = 2305108861,
        dofProjCompute = 2729164810,
        dofRenderTargetSize = 3995371223,
        DOFSampler = 2614429576,
        dofShear = 1387749709,
        dofSkyWeightModifier = 1603770318,
        DOFTargetSize = 3565962906,
        downsampledDepthSampler = 2057740952,
        DownsampleDepthSampler = 498175796,
        dpMapFarClip = 3395601267,
        dpMapNearClip = 479573217,
        drawBucket = 514782960,
        dReflectionParams = 153627866,
        droopParams = 2926981594,
        DruggedEffectColorShift = 4028255612,
        DruggedEffectParams = 858398664,
        dShadowMatrix = 3423656318,
        dShadowOffsetScale = 930807775,
        dShadowParam0123 = 3916656767,
        dShadowParam4567 = 584100066,
        dShadowParam891113 = 1698928349,
        DstTextureSize = 45365902,
        eaaParams2 = 1422359808,
        earlyOut = 3422479905,
        earlyOut_Sampler = 2971523439,
        earlyOutParams = 141437565,
        EastColor = 1417575779,
        EdgeMarkParams = 717226593,
        EdgeThreshold = 2670218238,
        EdgeThresholdMin = 316543927,
        effectsConstants = 1179101422,
        ElapsedTime = 4152310215,
        emissiveMultiplier = 1592520008,
        emissiveReflectMultiplier = 1347035993,
        EmitterParamLifeAndSpeed = 1295421465,
        EmitterParamPos = 2286595424,
        EmitterParamPosRange = 3505097448,
        EmitterParamProbablityPhase2 = 1652433309,
        EmitterTransform = 2216438402,
        EmitterVelocityBoxPos = 1027158774,
        EmitterVelocityBoxRange = 3202652030,
        EnvBloodBinormal = 304838968,
        EnvBloodData = 2241230170,
        EnvBloodPos = 3704052925,
        EnvBloodSampler = 3616483953,
        EnvBloodTangent = 1134317228,
        envEffFatThickness = 436649803,
        envEffScale = 2431974683,
        envEffTexTileUV = 3670603239,
        envEffThickness = 2702504809,
        EnvironmentSampler = 3317411368,
        Exposure = 2538078618,
        ExposureClampAndHistory = 2911392042,
        ExposureCurve = 1836476954,
        ExposureParams0 = 2329380491,
        ExposureParams1 = 1031924697,
        ExposureParams2 = 1253836365,
        ExposureParams3 = 301405380,
        Exposures = 2947662557,
        ExposureSwitches = 1784826898,
        faceTextureSampler = 624309278,
        facetMask = 4034105764,
        Fade_Thickness = 205855514,
        fadeAlphaDist = 4164097433,
        fadeAlphaDistUmTimer = 3637887135,
        fadeAlphaLOD1Dist = 3563207876,
        fadeAlphaLOD2Dist = 1294165969,
        fadeAlphaLOD2DistFar0 = 4248689351,
        fAge = 2063122051,
        FallOffAndKernelParam = 1703468999,
        fillColor = 3014106266,
        Filmic0 = 2611530409,
        fIntensity = 847954571,
        FlowSampler = 1214194352,
        FoamSampler = 3266349336,
        FogColor = 3922291195,
        FogParams = 1243028310,
        FogRayTexSampler = 1487203018,
        FogSampler = 2568933054,
        fogVolumeColor = 2907231751,
        fogVolumeDepthSampler = 1087981784,
        fogVolumeInvTransform = 786602411,
        fogVolumeParams = 10424280,
        fogVolumePosition = 2937842810,
        fogVolumeTransform = 1406518664,
        foliageBranchBendPivot = 353881103,
        foliageBranchBendStiffnessAdjust = 3429332683,
        FontNormalSampler = 3140496408,
        FontNormalScale = 91417371,
        FontSampler = 2048139100,
        FontTexture = 3394800319,
        fourPlaneDof = 2764191939,
        fpvMotionBlurSize = 1677050762,
        fpvMotionBlurVelocity = 4116905408,
        fpvMotionBlurWeights = 4038439571,
        FrameMap = 1835157646,
        FrameMapTexSampler = 507369750,
        Frequency1 = 2441536523,
        Frequency2 = 2219624855,
        fresnelRolloff = 3796399242,
        FullSampler = 3157511856,
        furAlphaClip03 = 290288684,
        furAlphaClip47 = 4280570754,
        furAlphaDistance = 4141869331,
        furAOBlend = 4026629301,
        furAttenCoef = 2491165204,
        furBendParams = 3489000159,
        furDitherAlphaFadeParams = 3407922321,
        furGlobalParams = 443249107,
        furLayerParams = 1122745807,
        furLayerParams2 = 3825466177,
        furLayerParams3 = 1668577832,
        furLayerStep = 1208356461,
        furLength = 1430134069,
        FurMaskSampler = 3794875320,
        furMaxLayers = 253873259,
        furMinLayers = 3007864804,
        furNoiseUVScale = 1008743034,
        furNumLayers = 110936794,
        furSelfShadowMin = 3093266608,
        furShadow03 = 1104745269,
        furShadow47 = 711397225,
        furStiffness = 2137279259,
        furUvScales = 897751165,
        g_AlphaFade = 1960511459,
        g_BloodColor = 985986992,
        g_BloodSplatParams = 1621619881,
        g_CPQSMix_QSFadeIn = 2799702011,
        g_CurrentValue = 1312005277,
        g_EdgeHighlightColour = 1596321467,
        g_f4RTSize = 4169783008,
        g_fBilateralCoefficient = 2015612345,
        g_fBilateralEdgeThreshold = 2771898508,
        g_fCollisionSqScale = 731874660,
        g_fEnableSpringForces = 2189248122,
        g_fGrassSpringRigidity = 3152689414,
        g_fGrassSpringScale = 2339438728,
        g_fRippleRainStrength = 2044767128,
        g_fSSAOBilateralCoef = 145680953,
        g_fSSAOKernelScale = 3370811738,
        g_fVolumetricLightRayIntensityMult = 3709677333,
        g_GBufferTexture3Param = 3145202593,
        g_GhostLevel = 1563742563,
        g_HDAO_Params1 = 1535730194,
        g_HDAO_Params2 = 3676889419,
        g_HDAOApplyParams = 2705555169,
        g_HDAOComputeParams = 2528000437,
        g_HDAOExtraParams = 3628503020,
        g_HDAOValleyParams = 1466262319,
        g_HighlightScale = 1705698884,
        g_ImposterSize = 786569893,
        g_LightningStrikeNoiseParams = 390679343,
        g_LightningStrikeParams = 3780586083,
        g_LinearClampSampler = 2261256735,
        g_MSAAPointTexture1_Dim = 3319333866,
        g_MSAAPointTexture2_Dim = 3715862146,
        g_OcclusionTextureParams = 4007914843,
        g_PointSampler = 3230386348,
        g_projParams = 360593454,
        g_projShear = 1833194361,
        g_Puddle_ScaleXY_Range = 529156535,
        g_PuddleParams = 3536830402,
        g_ResultTexture = 3349637075,
        g_SSAOStrength = 1519496158,
        g_targetSize = 1149055682,
        g_TextColour = 3414941892,
        g_TextShadowColour = 3326514923,
        g_TextShadowScale = 828975922,
        g_vCollisionParams = 390873962,
        g_vCollisionSpheres = 2187899533,
        g_vPlayerPosition = 148353768,
        g_vRelativeLuminanceThresholdParams = 1353171807,
        g_vRippleAttributes = 1686992389,
        g_vRippleTexelSize = 2041279531,
        g_vTexelSize = 1568580394,
        g_WaveXOffset = 2340128792,
        g_WaveXZoom = 1940934038,
        g_WaveYZoom = 936340354,
        g_WidthScalar = 1482315230,
        gActiveUnit = 247068080,
        GalaxyOffset = 2261454336,
        GalaxySampler = 304699295,
        gAlphaCutoffMinMax = 3012586280,
        gAlphaTest = 2215224122,
        gAlphaToCoverageScale = 955152299,
        gAmbientAmount = 862548646,
        gAmbientColor = 2502793579,
        gAmbientMult = 2621865253,
        gAmbientShadow = 1730637860,
        Gamma = 1617619096,
        GammaCorrection = 2923835982,
        gAnimatedNormalMapParams = 1356180523,
        gAnimBlendWeights = 3438696362,
        gAnimCombine = 4162938569,
        gAnimSculpt = 732819097,
        GaussianWeights = 3546535582,
        gBackgroundDistortionAlphaBooster = 1266153517,
        gBackgroundDistortionAmount = 2358946644,
        gBackgroundDistortionVisibilityPercentage = 1950755416,
        gBiasToCamera = 969255365,
        gBlitMatrix = 1903406607,
        gBloodData = 2470245206,
        gBloodUVBoundsPage = 318462180,
        gBlurAmount = 2372939986,
        gBoneDamage0 = 493675041,
        gBoneDamageEnabled = 3445557846,
        gBounceColor = 3285219193,
        gBoxCentrePos = 1213320064,
        gBoxForward = 2141719324,
        gBoxRight = 3950477470,
        gBoxSize = 4157270760,
        GBufferStencilTextureSampler = 34323572,
        gbufferTexture0 = 1370576551,
        gbufferTexture2 = 989669695,
        gbufferTextureDepth = 3214151316,
        GBufferTextureSampler0 = 3101514270,
        GBufferTextureSampler1 = 1931628197,
        GBufferTextureSampler2 = 1601349446,
        GBufferTextureSampler3 = 394499945,
        GBufferTextureSamplerDepth = 3001958741,
        GBufferTextureSamplerSSAODepth = 566345585,
        gCableParams = 3557855020,
        gCamAngleLimits = 1391293880,
        gCameraBias = 481136556,
        gCameraDistanceAtMaxDisplacement = 894396470,
        gCameraPos = 130109679,
        gCameraPosition = 3861036523,
        gCameraShrink = 196757553,
        gClipPlanes = 993087185,
        gCloudColor = 3349623462,
        gCloudViewProj = 1388118204,
        gCollisionLifeModifier = 28882798,
        gCollisionPositionModifier = 1413333801,
        gCollisionVelocityModifier = 2917041400,
        gColorTint = 1945696018,
        gColorTintPhase2 = 3971978241,
        gColour = 819380429,
        gColourSplash = 2769897443,
        gControlLight = 1458962865,
        gCrossFadeDistance = 2123742775,
        gCSMParticleShadowSamp = 18467538,
        gCSMParticleShadowTexture = 1879733647,
        gCSMShaderVars_deferred = 4041368736,
        gDayNightScale = 2033466401,
        gDecalChannelSelection = 129604674,
        gDecalNormalSampler = 353477773,
        gDecalSampler = 2317915042,
        gDeferredInverseViewProjMatrix = 3129339935,
        gDeferredLightColourAndIntensity = 3618208763,
        gDeferredLightConeAngle = 1457978794,
        gDeferredLightConeAngleI = 3706722404,
        gDeferredLightConeOffset = 2681954581,
        gDeferredLightConeScale = 3587849890,
        gDeferredLightDirection = 3096160936,
        gDeferredLightInvSqrRadius = 1076369960,
        gDeferredLightPosition = 3515628483,
        gDeferredLightRadius = 771816156,
        gDeferredLightRadiusProjShearParams = 507484242,
        gDeferredLightSampler = 1527752693,
        gDeferredLightSampler0P = 3029377315,
        gDeferredLightSampler1 = 575604989,
        gDeferredLightSampler2 = 1424289320,
        gDeferredLightShadowMap0 = 2826529087,
        gDeferredLightShadowMap1 = 2589969676,
        gDeferredLightShadowMap2 = 2224923016,
        gDeferredLightShadowMap3 = 1962213943,
        gDeferredLightShaftParams = 2784101259,
        gDeferredLightTangent = 3997363695,
        gDeferredLightType = 874695930,
        gDeferredLightVolumeParams = 371509596,
        gDeferredProjParams = 1174638206,
        gDeferredVolumeRadiusScale = 3037897088,
        gDensityShiftScale = 3043875162,
        gDepthViewProjMtx = 512139429,
        gDiffuse = 1220611861,
        gDirectional = 2203405262,
        gDirectionalLightShadowAmount = 3920559848,
        gDirectionalMotionBlurLength = 2219759593,
        gDirectionalMult = 4000928118,
        gDirectionalVelocityAdd = 1608450430,
        gDirectionalZOffsetMinRange = 955747368,
        gDirNormalBias = 1480114695,
        gDispersalSettings = 570820137,
        gDistanceScale = 3645463202,
        gEastMinusWestColor = 2332609458,
        gEdgeSoftness = 867642987,
        GeneralParams0 = 3458676571,
        GeneralParams1 = 3166540936,
        gExtraLightMult = 3645170126,
        gExtraLights = 2849007823,
        gExtraParams0 = 1363351178,
        gExtraParams1 = 3423931440,
        gExtraParams2 = 4223069043,
        gExtraParams3 = 3907306959,
        gExtraParams4 = 2518327352,
        gFadeInOut = 1682568218,
        gFadeNearFar = 1244256289,
        gFadeZBaseLoHi = 542136670,
        gFirstTimeUpdate = 92947686,
        gFogCompositeAmbientColor = 2918893733,
        gFogCompositeDirectionalColor = 646659969,
        gFogCompositeParams = 3080532465,
        gFogCompositeTexOffset = 1705135815,
        gFrustumParameters = 1069442784,
        gGrassSkipInstance = 3294601711,
        gGravityWindTimeStepCut = 2189578124,
        gGustAmplifier = 1813609204,
        gGustSpacing = 2572448010,
        gHDRExposure = 1986583430,
        gHeatHaze = 1822868744,
        gHeatHazeRippleLength = 1850681702,
        gHeatHazeRippleRate = 3558453078,
        gHeatHazeScale = 3312170287,
        gHeatHazeSize = 1319873596,
        gHeatHazeWidth = 3133152963,
        gHeatPhase = 2721110750,
        gHitPlane = 3729639013,
        ghorizScale = 2467525454,
        gHybridAddRatio = 3504408232,
        gInstanceVars = 3432648184,
        gInstCullParams = 3871720938,
        gIntensity = 3311833552,
        gInterpolationFactor = 1392131636,
        gIsShadowPass = 1999109769,
        gLifeFade = 1079477869,
        gLifeMinMaxClampToGround = 3942952480,
        gLifeTimeScale = 3294686231,
        gLightIntensityClamp = 4186188647,
        gLightIntensityMult = 1884220195,
        gLightSettings = 1029904424,
        globalAnimUV0 = 3617324062,
        globalAnimUV1 = 3126116752,
        globalFogRayFadeParam = 1248095708,
        globalFogRayParam = 1620085657,
        globalFreeAimDir = 3943027507,
        gLocalLightsMultiplier = 4293612306,
        gLodFadeControlRange = 4185950307,
        gLodFadePower = 2662986932,
        gLodFadeRange = 3264171975,
        gLodFadeStartDist = 1949054155,
        gLodFadeTileScale = 1082098581,
        gLodInstantTransition = 596864795,
        gLodThresholds = 979130770,
        gLowResDepthSampler = 2824212180,
        gLowResDepthTexture = 3015483598,
        gMaxDisplacement = 1164495840,
        gMaxLife = 3970444018,
        gMirrorBounds = 1887204037,
        gMirrorCrackAmount = 1562064116,
        gMirrorCrackSampler = 2984091644,
        gMirrorDebugParams = 496893366,
        gMirrorDistortionAmount = 987148199,
        gMotionBlur = 294407736,
        gNearFarQMult = 2513511302,
        gNormalArc = 808788377,
        gNormalHeight = 3146080364,
        gNormalMapMult = 3282331164,
        gNormalOffset = 2355039984,
        gNormalScale = 2365712398,
        gNumClipPlanes = 828848872,
        gOffsetParticlePos = 842278893,
        gOffsetScale0 = 70492586,
        gOffsetScale1 = 428526680,
        goldFactor = 358396505,
        goldFresnelRolloff = 295546023,
        goldReflectColorBase = 2396384524,
        goldReflectColorOverlay = 2603016628,
        goldReflectivePower = 2990597200,
        goldSpecMapIntMask = 1333698176,
        goldSpecularFactor = 435211370,
        GolfTrailTextureSamp = 241657115,
        gooDeferredLightScreenSize = 3073062802,
        gOrientToTerrain = 3165461554,
        gParticleColorPercentage = 1853363478,
        gParticleTextureSize = 2550169896,
        gPerspectiveShearParams0 = 2149148446,
        gPerspectiveShearParams1 = 509977564,
        gPerspectiveShearParams2 = 263128687,
        gPiercingLightPower_Strength_NormalStrength_Thickness = 2302032860,
        gPositionOffset = 2734209203,
        gPositionScale = 4212665338,
        gPower = 1384422613,
        gPrevViewProj = 1120562824,
        gProjParams = 2311871851,
        GradientFilterColBottom = 3762433606,
        GradientFilterColMiddle = 1794637696,
        GradientFilterColTop = 4015194706,
        gRadius = 526220184,
        gRainDebug = 1247076385,
        gravityDroop = 3181978688,
        GreenOff = 3283681954,
        gReflScales = 1520419346,
        gRefParticlePos = 2705128804,
        gRefraction = 2643069888,
        gRescaleUV1 = 724216589,
        gRescaleUV2 = 2046871736,
        gRescaleUV3 = 2259804698,
        gResetParticles = 2831259018,
        gRG_BlendEndDistance = 3347456804,
        gRG_BlendStartDistance = 4179423620,
        gRotationCenter = 2718167535,
        gRotSpeedMinRange = 3733294048,
        groundColor = 3169191053,
        gScaleDiffuseFillAmbient = 397913198,
        gScaleFade = 3144708943,
        gScaleRange = 4248652172,
        gScatterG_GSquared_PhaseMult_Scale = 987241318,
        gShadowAmount = 3297538021,
        gSizeMinMax = 1571728947,
        gSizeMinRange = 3419056622,
        gSkyColor = 3328933361,
        gSoftness = 2874180382,
        gSoftnessCurve = 2667435005,
        gSoftnessShadowMult = 2718764463,
        gSoftnessShadowOffset = 2710273761,
        gSoftParticleRange = 3901093204,
        gSpecularExponent = 3204977572,
        gSpecularIntensity = 247886295,
        gSplashFrames = 944333453,
        gSplashSizeMinMax = 4062424283,
        gSunColor = 3007207522,
        gSunDirection = 2009439163,
        gSuperAlpha = 1225534059,
        gSurfaceSettings = 3834090438,
        gtaSkyDomeClip = 964033580,
        gtaSkyDomeFade = 826009472,
        gtaWaterColor = 4280744704,
        gTexCoordScaleOffset0 = 3099617970,
        gTexCoordScaleOffset1 = 2745647232,
        gTexCoordScaleOffset2 = 2499388197,
        gTexCoordScaleOffset3 = 2456002041,
        gTextureAngleRads = 241993590,
        gTextureAnimation = 20918084,
        gTextureAnimRateScaleOverLifeStart2End2 = 3412279679,
        gTextureRowsCols = 1276450911,
        gTextureRowsColsStartEnd = 1241308942,
        gTotalLifeTimeScale = 2824822244,
        gUseComputeShaderOutputBuffer = 1009029736,
        gUseDirectional = 1281964389,
        gUseShadows = 345674786,
        gUVOffset = 3300015766,
        gUVOffset1 = 2565276602,
        gUVOffset2 = 2325899053,
        gUVOffset3 = 3510465638,
        gVelocityMax = 3037552071,
        gVelocityMin = 507774218,
        gvertScale = 1074904593,
        gViewProj = 4124209033,
        gVolumeLightsSampler = 1687175937,
        gVolumeLightsTexture = 2884407863,
        gWaterHeight = 446050918,
        gWestColor = 3223173913,
        gWindBaseVel = 3813992546,
        gWindBendingGlobals = 709598663,
        gWindBendScaleVar = 2552738797,
        gWindGustVel = 2099280216,
        gWindMultParams = 982613925,
        gWindParams = 3536772057,
        gWindVarianceVel = 2216170969,
        gWorldBinormal = 2267341197,
        gWorldInstanceInverseTranspose = 1914807,
        gWorldInstanceMatrix = 981286173,
        gWorldTangent = 1317093162,
        gWrapBias = 1858190163,
        gWrapLighting = 75905342,
        gWrapLighting_MSAARef = 833328952,
        gWrapScale = 3087563039,
        gZdampen = 2165766204,
        HardAlphaBlend = 3913511942,
        HDRColorTexture = 2362960420,
        HDRExposure = 3039323892,
        HDRExposureClamp = 1487577326,
        hdrIntensity = 4136287658,
        HDRIntensityMultiplier = 1498595219,
        HDRPointSampler = 3702694755,
        HDRSampler = 1709735268,
        HDRSunExposure = 81989056,
        HDRTextureAA = 2769796592,
        HeatHazeOffsetParams = 234272229,
        HeatHazeParams = 3041693270,
        HeatHazeSampler = 2900829390,
        HeatHazeTex1Params = 157461750,
        HeatHazeTex2Params = 3686416465,
        heightBias = 330974467,
        heightBias0 = 537974167,
        heightBias1 = 820082484,
        heightBias2 = 3378489398,
        heightBias3 = 3161525849,
        HeightFogParams = 4202365273,
        HeightMapSampler = 1008099585,
        heightMapSamplerLayer0 = 781078585,
        heightMapSamplerLayer1 = 2570495372,
        heightMapSamplerLayer2 = 2346748640,
        heightMapSamplerLayer3 = 2242969217,
        HeightMapTransformMtx = 1556799447,
        HeightOpacity = 2935469584,
        heightSampler = 4049987115,
        heightScale = 947222050,
        heightScale0 = 2807156689,
        heightScale1 = 1898472319,
        heightScale2 = 2178811114,
        heightScale3 = 1536800866,
        heightTexture = 4152773162,
        hemi_bias = 3477916617,
        hemi_near = 4068871657,
        hemi_params = 3188015657,
        hemi_range = 2843854391,
        hemi_res = 3411758646,
        HemiCubeSampler = 145567721,
        hiDofMiscParams = 851407070,
        hiDofParams = 3302089350,
        HighDetailNoiseBumpSampler = 1044331566,
        HighDetailNoiseSampler = 3822359214,
        highDetailSampler = 860147427,
        highLum = 737146002,
        history = 2023011857,
        HmdWarpParam = 4161661017,
        horizonLevel = 403229780,
        HybridAdd = 4234023609,
        HybridAddRatio = 1902453223,
        ImageFXParams = 3775812724,
        importanceBufferSampler = 1983941369,
        imposterDir = 15105794,
        imposterSampler = 4013138833,
        imposterWorldX = 3187870439,
        imposterWorldY = 3495145352,
        imposterWorldZ = 4037865530,
        InitPositionTexSampler = 867916958,
        InitVelocityTexSampler = 3796043845,
        InputTex = 2352384719,
        InstanceBuffer = 571392628,
        InterlaceIndex = 92545662,
        InterlaceMapSampler = 4281682490,
        InterlaceTotalNum = 1200425084,
        intermediateTarget = 2216618306,
        intermediateTarget_Sampler = 1179275796,
        intermediateTargetAA = 2580729000,
        JitterSampler = 887426944,
        kernelParam = 348424870,
        kernelRadius = 1819724113,
        KillFlashCol = 1705946031,
        KillFlashUVOff = 1449898229,
        LaserSampler = 3973852449,
        LaserVisibilityMinMax = 2050561467,
        LastBufferSize = 878694393,
        LensArtefactsParams0 = 1487316152,
        LensArtefactsParams1 = 870406958,
        LensArtefactsParams2 = 1165295189,
        LensArtefactsParams3 = 263361233,
        LensArtefactsParams4 = 2409501354,
        LensArtefactsParams5 = 1794558296,
        LensCenter = 163655085,
        LensDistortionParams = 705844615,
        LetterIndex1 = 1794007338,
        LetterIndex2 = 865825409,
        LetterSize = 1497980819,
        LicensePlateFontExtents = 3015810411,
        LicensePlateFontTint = 1846736030,
        LightColor = 1945364554,
        LightDir = 1608210580,
        LightOcclusionSampler = 3039301469,
        lightrayParams = 912013868,
        lightrayParams2 = 3575716412,
        LightStreaksBlurDir = 2085391682,
        LightStreaksColorShift0 = 4082051348,
        LinearSampler = 2135833848,
        LinearSampler1 = 4052371224,
        LinearSampler2 = 2627575128,
        LinearWrapSampler = 681732347,
        LinearWrapSampler2 = 1379901712,
        LinearWrapTexture3 = 4011882001,
        lookupSampler = 2295086480,
        lowLum = 2175272747,
        LowResDepthMapPointSampler = 1894550764,
        LowResDepthPointMap = 4131434726,
        LumFilterParams = 2120745528,
        LuminanceConstants = 2215984599,
        LuminanceDownsampleOOSrcDstSize = 1869154352,
        lunarCycle = 3166975708,
        manualDepthTest = 2024632841,
        MaskAlphaReverse = 3046988116,
        maskTextureSampler = 2110569141,
        matDiffuseColor = 408880252,
        matDiffuseColor2 = 1577977996,
        matDiffuseColorTint = 99676333,
        materialDiffuse = 424198508,
        materialIdSampler = 892830080,
        materialWetnessMultiplier = 3170143313,
        matGrassTransform = 72771513,
        matMaterialColorScale = 2492093682,
        matWheelTransform = 2829072482,
        matWheelWorld = 3178367768,
        matWheelWorldViewProj = 2078334811,
        MBPerspectiveShearParams0 = 1033188477,
        MBPerspectiveShearParams1 = 2555242989,
        MBPerspectiveShearParams2 = 2292140688,
        MBPrevViewProjMatrixW = 556540040,
        MBPrevViewProjMatrixX = 2198692937,
        MBPrevViewProjMatrixY = 2433876050,
        MipMapLod = 482766300,
        mirrorIntensity = 2215660639,
        mirrorNormalIntensity = 1531688027,
        mirrorParams = 2538518895,
        mirrorReflectionSkyIntensity = 3525553109,
        mirrorSpecMaskIntensity = 2901241109,
        MLAAAreaLUTSampler = 2609019681,
        MLAALinearSampler = 655764451,
        MLAAPointSampler = 1645524956,
        moonColor = 2213576281,
        MoonColorConstant = 2616626323,
        moonDirection = 3484629706,
        MoonGlow = 2037987613,
        MoonGlowSampler = 2151873246,
        moonIntensity = 2342189917,
        MoonLight = 2593156215,
        moonPosition = 124803246,
        moonSampler = 1534106922,
        moonTexConvert = 1796762296,
        MoonTexPosition = 1128557715,
        MoonVisiblity = 3257982346,
        MoonXVector = 1764174018,
        MoonYVector = 3157759019,
        motionBlurMatrix = 2950235179,
        MotionBlurSampler = 3974544708,
        MP_BulletTimeParams = 51894946,
        MSAAPointSampler1 = 3816347419,
        MSAAPointTexture1 = 750933622,
        MSAAPointTexture2 = 989590249,
        nearFarClip = 1899734512,
        Noise1Sampler = 3941892287,
        Noise2Sampler = 215717268,
        noiseDensityOffset = 3780934309,
        NoiseFilterArea = 1418684055,
        noiseFrequency = 1364176943,
        noiseHighLum = 3113827561,
        noiseLowLum = 3302331435,
        noiseLum = 1493025892,
        NoiseMapSampler = 2678081716,
        NoiseParams = 2296796634,
        noisePhase = 1916643725,
        NoiseSampler = 2461808165,
        noiseScale = 4186750186,
        noiseSoftness = 984327287,
        NoiseTexSampler = 651303591,
        noiseTexture = 1661149109,
        NoiseTextureSampler = 4127640691,
        noiseThreshold = 188180875,
        NoiseWarp = 1708817206,
        normalBuffer = 3727614344,
        normalBufferSamp = 3334794412,
        normalMapBlendRatio = 432051653,
        normalMapMod = 1363116819,
        NormalMapSampler = 860923645,
        NormalMapSampler1 = 225912280,
        NormalMapSampler2 = 4224746123,
        NormalMapTexSampler = 2007347265,
        normalSampler = 2327911600,
        NormalSpecMapTexSampler = 2275171214,
        normalTexture = 3453458978,
        NormalTextureSampler = 53266845,
        NormBufferSampler = 2450983583,
        normFresnelRolloff = 469438475,
        normReflectivePower = 99909810,
        normSpecMapIntMask = 4286481776,
        normSpecularFactor = 106090312,
        normTable = 478874367,
        numActiveShadowCascades = 2608506194,
        NumLetters = 1303240218,
        occlusionSampler = 50748941,
        occlusionTexture = 2967810622,
        OceanLocalParams0 = 2333080707,
        offsetHighLum = 3768233024,
        offsetLowLum = 1745892694,
        offsetLum = 3139368420,
        orderNumber = 1617153586,
        paletteColor0 = 2390234167,
        paletteColor1 = 345546874,
        paletteColor2 = 650331343,
        paletteColor3 = 1102019239,
        paletteIndex = 2499973182,
        PaletteSampler = 2950395616,
        paletteSelector = 2636279676,
        paletteSelector2 = 588791948,
        ParabSampler = 2604688681,
        parallaxScaleBias = 2178632789,
        parallaxSelfShadowAmount = 242286661,
        param0 = 3022832690,
        param1 = 1630936646,
        param2 = 2407332563,
        param3 = 2110904189,
        param4 = 739161080,
        param5 = 411995384,
        param6 = 1178691677,
        param7 = 947113154,
        params_ = 890816472,
        ParticleCollisionSampler = 3713958763,
        ParticlePosTexSampler = 2603657112,
        ParticlePosXYTexSampler = 2279694207,
        ParticlePosZWTexSampler = 1408622679,
        particleShadowsParams = 2589755661,
        ParticleVelTexSampler = 1792971393,
        ParticleVelXYTexSampler = 3377719961,
        ParticleVelZWTexSampler = 572101329,
        PedBrightness = 2965570322,
        PerlinNoiseSampler = 2192344499,
        perlinSampler = 3428612092,
        Persistance = 319450804,
        perspectiveShearParam = 686675449,
        Phase = 2726250539,
        plantColor = 1360494706,
        PlateBgBumpSampler = 1709116366,
        PlateBgSampler = 1342317448,
        PLAYER_MASK = 2584097651,
        PlayerBrightness = 1987993393,
        playerLFootPos = 1466936,
        playerRFootPos = 982297002,
        PointSampler = 1728781698,
        PointSampler1 = 857651826,
        PointSampler2 = 2186729701,
        PointTexture1 = 3319640342,
        PointTexture2 = 463756450,
        PointTexture3 = 715389601,
        PointTexture4 = 4030629335,
        PointTexture5 = 4280230808,
        poisson12 = 3700554683,
        polyRejectThreshold = 3669125377,
        PositionTexSampler = 124136329,
        PostFXAdaptiveDofCustomPlanesParams = 2921923875,
        PostFXAdaptiveDofEnvBlurParams = 383528417,
        PostFxSampler2 = 3640527007,
        PostFxSampler3 = 1268084184,
        postProcess_FlipDepth_NearPlaneFade_Params = 1212194473,
        projectionParams = 4041985547,
        PRTOccSampler = 3756087939,
        PtfxAlphaMapSampler = 2528190781,
        PtfxDepthMapSampler = 3549846349,
        PuddleBumpSampler = 644999851,
        PuddleMaskSampler = 1899494261,
        PuddlePlayerBumpSampler = 375060758,
        QuadAlpha = 319478650,
        QuadPosition = 4152407657,
        QuadScale = 876246817,
        QuadTexCoords = 2382487901,
        QualitySubpix = 1192820550,
        radialBlurCenter = 265875256,
        RadialBlurSampler = 6871558,
        radialBlurSampleScale = 1978511676,
        radialBlurScale = 847338530,
        radialBlurTextureStep = 3637740945,
        RadialFadeArea = 3417034203,
        RadialFadeTime = 820208297,
        RadialWaveParam = 4020440334,
        //radius = 1337695475,
        RainNormalControls = 2413728713,
        RainNormalSampler = 205121072,
        RawInstanceBuffer = 2533822745,
        rcpFrame = 3616804746,
        RedOff = 550595403,
        reductionDepthTexture = 156102219,
        ReductionOutputTexture = 3090928251,
        RefBlurMapSampler = 553137719,
        ReflectanceSampler = 2024624668,
        reflectivePower = 1002989215,
        reflectivePowerED = 680514554,
        ReflectTextureSampler = 2975449189,
        refMipBlurParams = 309170118,
        RefMipBlurSampler = 3559513422,
        RefractionMapTexSampler = 3189040505,
        RefractSampler = 2398824821,
        RenderCubeMapSampler = 3123859691,
        RenderMapPointSampler = 1552806584,
        RenderMapPointSamplerMSAA = 840576025,
        RenderPointMapINT = 3218359854,
        RenderPointMapINTParam = 945456412,
        RenderTargetSize = 2592035668,
        RenderTexArray = 183558417,
        RenderTexArraySampler = 1776075411,
        RenderTexFmask = 334637039,
        RenderTexMSAA = 2388364099,
        RenderTexMSAAINT = 1120019968,
        RenderTexMSAAParam = 445950974,
        RESERVE_VS_CONST_c253 = 888979958,
        RESERVE_VS_CONST_c254 = 572824646,
        RESERVE_VS_CONST_c255 = 3578071436,
        ResolvedDepthSampler = 870591330,
        ResolvedDepthTexture = 1168394501,
        Result = 1204638111,
        rimAmount = 3950947166,
        rimPower = 1017175370,
        RippleBumpiness = 3108440880,
        RippleData = 1154845288,
        RippleScale = 3553443429,
        RippleScaleOffset = 1931187426,
        RippleSpeed = 1172914979,
        ropeColor = 3402942199,
        samp = 4292969706,
        sampFiltered = 200703167,
        sampleAngle = 1030071922,
        sampleScale = 65527032,
        Scale_ = 116180525,
        scale_ = 3279249823,
        Scale = 1018839014,
        scale = 1342385372,
        ScaleIn = 1489667163,
        scalerLum = 1241172112,
        ScanlineFilterParams = 3994711222,
        ScreenBlurFade = 337464727,
        ScreenCenter = 2855930302,
        screenRes = 2982944708,
        ScreenRez = 1216400687,
        ScreenSizeHalfScale = 3116016449,
        SeamTextureSampler = 1888072213,
        seeThroughColorFar = 3831201608,
        seeThroughColorNear = 3012901639,
        seeThroughColorVisibleBase = 2159046948,
        seeThroughColorVisibleWarm = 3370209405,
        seeThroughParams = 4084639067,
        SegmentSize = 2511004421,
        SelfShadowing = 1840833647,
        SfxWindSampler3D = 2060224441,
        shader_cableAmbient = 2538368771,
        shader_cableDiffuse = 1793087594,
        shader_cableDiffuse2 = 115414613,
        shader_cableEmissive = 132015748,
        shader_fadeExponent = 2415019593,
        shader_radiusScale = 2225356731,
        shader_windAmount = 33262047,
        shaderVariables = 2308502112,
        ShadowFacingOffset = 2069856698,
        ShadowFalloff = 1293272419,
        shadowmap_res = 4230725802,
        shadowMapSamp = 4212336983,
        shadowParams2 = 2293499745,
        skinColourTweak = 2856526403,
        SkinParams = 441924618,
        SkyColor = 1706854363,
        SkyMapSampler = 2000097477,
        skyPlaneColor = 3575965978,
        skyPlaneParams = 2005428036,
        smallCloudColorHdr = 1741381730,
        smallCloudColorXHdrIntensity = 2180964324,
        smallCloudConstants = 376734756,
        SmartBlitCubeMapSampler = 4204135808,
        SmartBlitCubeMapTexture = 712004116,
        SmartBlitSampler = 909202272,
        SmartBlitTexture = 4234899854,
        SmokeParams = 2945162076,
        SmokeSampler = 2479196183,
        SnowSampler = 3153629680,
        SnowSampler0 = 43291740,
        SnowSampler1 = 296170113,
        SoakFrameInfo = 2322806119,
        //Softness = 187712958, //softness is already in the list, used by types other than shaders!
        source = 572563616,
        SpecDesaturateExponent = 3019471088,
        SpecDesaturateIntensity = 716647240,
        SpecExp = 191070201,
        specFalloffAdjust = 227128491,
        specFresnelExp = 1058370591,
        specFresnelMax = 4192555480,
        specFresnelMin = 1243102889,
        SpecIntensity = 3710484485,
        specIntensityAdjust = 4171608282,
        specMapExpMask = 1709596004,
        specMapIntMask = 4279333149,
        specMapReflectMask = 3348420270,
        SpecSampler = 1619499462,
        SpecSampler_layer01 = 2048257998,
        SpecSampler_layer23 = 3596135066,
        specTexTileUV = 1430901041,
        specular2Color = 685871723,
        specular2Color_DirLerp = 2732605880,
        specular2ColorIntensity = 3929351910,
        specular2ColorIntensityED = 1998056897,
        specular2ColorIntensityRE = 4172410899,
        specular2Factor = 629012244,
        specular2FactorED = 3425067163,
        specularColorFactor = 1212833469,
        specularColorFactor1 = 475502710,
        specularColorFactor2 = 1361248780,
        specularColorFactor3 = 1060953664,
        specularColorFactorED = 1250428158,
        specularFactor = 376311761,
        specularFactor1 = 1627805193,
        specularFactor2 = 2405249722,
        specularFactor3 = 3075146389,
        specularFactorED = 2497120655,
        SpecularFalloff = 3957040118,
        specularFalloffMult = 2272544384,
        specularFalloffMultSpecMap = 2748867194,
        specularFresnel = 666481402,
        SpecularIntensity = 2841625909,
        specularIntensityMult = 4095226703,
        specularIntensityMultSpecMap = 1058366663,
        specularNoiseMapUVScaleFactor = 3472765508,
        SpecularPower = 2313518026,
        speedConstants = 4031543803,
        sphereReflectionSkyIntensity = 798112437,
        SplatterFrameInfo = 1795230185,
        srcTextureSize = 2371438916,
        sslrCenter = 2233700119,
        sslrParams = 2393555267,
        SSLRSampler = 362115574,
        StarFieldBrightness = 257351982,
        starfieldIntensity = 1720801864,
        StarFieldSampler = 4148544921,
        StarFieldUVRepeat = 2211182669,
        StarThreshold = 2069166037,
        StencilCopy = 2849038798,
        StencilCopySampler = 2084502919,
        StencilCopyTexture = 526908546,
        StencilTech = 471113370,
        StippleSampler = 3178703610,
        StubbleControl = 3996109161,
        SubColor = 3318550136,
        SubScatWidth = 993622972,
        SubScatWrap = 511449331,
        SubsurfaceColor = 1759569064,
        SubsurfaceIntensity = 1096960668,
        SubsurfaceRollOff = 3870878664,
        SubViewportParams = 2820867500,
        SunAxias = 2561150543,
        SunCentre = 240054980,
        sunColor = 891485471,
        sunColorHdr = 1049428866,
        sunColour = 1204497173,
        sunConstants = 1546824331,
        sunDirection = 2607379178,
        sunDiscColor = 3557539369,
        sunDiscColorHdr = 1079908950,
        SunElevation = 569130658,
        sunHdrIntensity = 3152536124,
        sunPosition = 2950046911,
        SunRaysParams = 291571442,
        SunsetColor = 2702399089,
        SunSize = 1478210724,
        SurfaceTextureSampler = 3864743319,
        SweatMapSampler = 2330958813,
        switchOn = 3150944317,
        targetSize = 1880392259,
        targetSizeParam = 1053269285,
        TearGasParams = 1288904305,
        TerrainGridCentrePos = 3625956620,
        TerrainGridForward = 1519085164,
        TerrainGridHighHeightCol = 580500403,
        TerrainGridLowHeightCol = 2936084960,
        TerrainGridMidHeightCol = 2606299729,
        TerrainGridParams = 1298168495,
        TerrainGridParams2 = 3179684830,
        TerrainGridRight = 1294931141,
        tessellationMultiplier = 1934793340,
        TexelSize = 3160646551,
        Texm = 169731954,
        TextureClamp = 812052183,
        TextureGrassSampler = 4087226378,
        TextureNoWrapSampler = 2957556365,
        textureSamp = 485865047,
        TextureSampler = 726757629,
        TextureSampler_layer0 = 3576369631,
        TextureSampler_layer1 = 606121937,
        TextureSampler_layer2 = 831736502,
        TextureSampler_layer3 = 2025281789,
        TextureSampler_layer4 = 235963313,
        TextureSampler_layer5 = 1429049834,
        TextureSampler_layer6 = 1784855636,
        TextureSampler2 = 90460676,
        TextureSamplerDiffPal = 2878898974,
        TextureSize = 3986548189,
        TiledLightingSampler = 3579496475,
        TimeOfDay = 1778950238,
        TintBlendAmount = 481228442,
        tintBlendLayer0 = 549865893,
        tintBlendLayer1 = 3618355041,
        tintBlendLayer2 = 3305181708,
        tintBlendLayer3 = 4225662918,
        tintBumpiness = 3412667425,
        tintBumpSampler = 3461703736,
        TintIntensity = 3676759262,
        TintPaletteSampler = 4131954791,
        tintPaletteSelector = 4258764495,
        tintSampler = 1530343050,
        tonemapColorFilterParams0 = 324960120,
        tonemapColorFilterParams1 = 48979602,
        TonemapParams = 2402343587,
        TopCloudBiasDetailThresholdHeight = 2470194715,
        TopCloudColor = 2654156795,
        TopCloudDetail = 3891329052,
        TopCloudHeight = 1826174990,
        TopCloudLight = 1738437051,
        TopCloudThreshold = 1907493970,
        topLum = 2532426199,
        TotalElapsedTime = 3838297418,
        TrackAnimUV = 3759799674,
        TransColor = 2460231751,
        TransparentDstMapSampler = 2450925918,
        TransparentSrcMap = 2768420156,
        TransparentSrcMapSampler = 3675757750,
        TransPos = 3580147959,
        TransTex0 = 719147892,
        TransTex1 = 1023997899,
        TransTex2 = 88705101,
        treeLod2Normal = 1105633214,
        treeLod2Params = 1951298816,
        txABC_Texture = 737921561,
        txCOC_Texture = 849209715,
        txX_Texture = 2443058410,
        txYn_Texture = 314367857,
        tyreDeformParams = 1573146290,
        tyreDeformParams2 = 4085683888,
        tyreDeformSwitchOn = 1318515464,
        UIColor = 2438354415,
        UIColorXformOffset = 805638785,
        UIColorXformScale = 1696850869,
        UIPosMtx = 2371642382,
        UIPremultiplyAlpha = 653605664,
        UITex0Mtx = 1320157902,
        UITex1Mtx = 2219459259,
        UITexture0 = 3890278027,
        UITexture1 = 3587000932,
        umGlobalOverrideParams = 3341722211,
        umGlobalParams = 570415642,
        uMovementParams = 3156484982,
        umTriWave1Params = 1002429420,
        umTriWave2Params = 1181853954,
        umTriWave3Params = 2191838184,
        UnderLightStrength = 618284065,
        unsharpAmount = 982234565,
        UpdateOffset = 1690179723,
        UpdateParams0 = 1210532871,
        UpdateParams1 = 1947442147,
        useTessellation = 1176544093,
        UseTreeNormals = 3771895108,
        UVScalar = 2343745306,
        uvScales = 2395163223,
        vBoneVelocitiesX = 58804251,
        vBoneVelocitiesY = 2266287952,
        vCustomData = 2809044919,
        vecBatchAabbDelta = 2709975619,
        vecBatchAabbMin = 1568822605,
        vecCameraPos = 3890753729,
        vecPlayerPos = 2050268192,
        vehglassCrackTextureParams = 3043112491,
        vehglassCrackTextureSampler = 3541769459,
        Velocity1 = 1362920836,
        Velocity2 = 1853341690,
        VelocityBufferSampler = 415075366,
        VelocityMapSampler = 3944176109,
        VelocityTexSampler = 2305380067,
        vHairParams = 4131157628,
        viewProj = 1758764692,
        viewToWorldProjectionParam = 3809745575,
        VignettingColor = 587686680,
        VignettingParams = 2870132669,
        VisibleInstanceBuffer0 = 3815124047,
        VisibleInstanceBuffer1 = 774685147,
        VisibleInstanceBuffer2 = 443193943,
        VisibleInstanceBuffer3 = 2592414350,
        vNoiseParams = 1120961721,
        vol_offsets = 2154022121,
        VolumeSampler = 789275230,
        vSkinSweat = 3181015961,
        vSweatParams = 3596190507,
        WaterBumpParams = 126236009,
        waterColor = 4201563883,
        WaterColorSampler = 1938107181,
        waterColour = 217812784,
        WaterFogFadeColor = 93338982,
        waterfogPtfxParams = 1185901400,
        WaterHeight = 276101176,
        waterIntensity = 3098236963,
        waterReflectionScale = 386931249,
        waterReflectionSkyIntensity = 4202734524,
        waterRenderSimParam = 3115418423,
        WaterRippleSampler = 3870579404,
        waterSimParam = 1441798312,
        waterSimParams1 = 764072840,
        waterSimParams2 = 2978995088,
        WaterSurfaceSampler = 4239336251,
        waterTexResValue = 1128648105,
        WaveMovement = 683816830,
        WaveOffset = 2296487471,
        WestColor = 2977103135,
        WetAnisotropicSpecular = 1297501138,
        WetAnisotropicSpecularColour = 4244410187,
        WetDarken = 3170546064,
        wetnessMultiplier = 853385205,
        WindGlobalParams = 208642390,
        WindStr = 3237952635,
        WoundFrameInfo = 2347313451,
        wrapAmount = 477869607,
        wrapLigthtingTerm = 850731621,
        WrinkleMaskSampler_0 = 2261465245,
        WrinkleMaskSampler_1 = 3567506505,
        WrinkleMaskSampler_2 = 2959477710,
        WrinkleMaskSampler_3 = 3181913682,
        WrinkleMaskSampler_4 = 199377605,
        WrinkleMaskSampler_5 = 498853496,
        wrinkleMaskStrengths0 = 3696993600,
        wrinkleMaskStrengths1 = 3993356436,
        wrinkleMaskStrengths2 = 9399719,
        wrinkleMaskStrengths3 = 1226342076,
        WrinkleSampler_A = 2285332697,
        WrinkleSampler_B = 163310560,
        YPlaneSampler = 2291309475,
        YUVtoRGB = 361269406,
        zenithColor = 1379881353,
        zenithConstants = 2801684,
        zenithTransitionColor = 3025743240,
        ZoomBlurMaskSize = 1914884772,
        ZoomFocusDistance = 2687037299,
        zShift = 2743864906,
        zShiftScale = 273550094,











        //CEntityDef = 0xce501483,
        //CMapData = 0xd3593fa6,
        //CBaseArchetypeDef = 0x82d6fc83,
        //CTimeArchetypeDef = 0x76B0C56C,
        //CTimeCycleModifier = 0x674f9350,
        //CExtensionDefAudioCollisionSettings = 0x15deda27,
        //CExtensionDefAudioEmitter = 0x2604683b,
        //CExtensionDefParticleEffect = 0x3a26e5e1,
        //CMapTypes = 0xd98bb561,
        //CExtensionDefLadder = 0x821d5421,
        //CExtensionDefBuoyancy = 0x2CB3D4E3,
        //CExtensionDefSpawnPoint = 0xC4B2F638,
        //CCarGen = 1860713439,
        //CExtensionDefExplosionEffect = 104349545,
        //CMloInstanceDef = 164374718,
        //CMloRoomDef = 186126833,
        //CExtensionDefDoor = 1965932561,
        //CExtensionDefProcObject = 2565191912,
        //CMloPortalDef = 2572186314,
        //CExtensionDefSpawnPointOverride = 2716862120,
        //CExtensionDefLightShaft = 2718997053,
        //CMloArchetypeDef = 273704021,
        //CMloEntitySet = 3601308153,
        //CExtensionDefExpression = 3870521079,
        //CLightAttrDef = 4115341947,
        //CExtensionDefWindDisturbance = 569228403,
        //CExtensionDefLightEffect = 663891011,
        //CMloTimeCycleModifier = 807246248,
        //rage__phVerletClothCustomBounds = 847348117,
        //SectionUNKNOWN1 = 1701774085, //cloth CollisionData (child of rage__phVerletClothCustomBounds)
        ////SectionUNKNOWN2 = 1185771007, //CCompositeEntityType
        //SectionUNKNOWN3 = 1980345114,
        ////SectionUNKNOWN4 = 2085051229,
        //SectionUNKNOWN5 = 2741784237, //occludeModels
        ////SectionUNKNOWN6 = 3985044770,
        //SectionUNKNOWN7 = 975711773, //boxOccluders
        //SectionUNKNOWN8 = 3430328684,//0xCC76A96C,
        VECTOR3 = 3805007828,//0xe2cbcfd4, //this hash isn't correct, but is used in CDistantLODLight

        VECTOR4 = 0x33, //(was SectionUNKNOWN12)
        HASH = 0x4a,
        STRING = 0x10,
        POINTER = 0x7,
        USHORT = 0x13,
        UINT = 0x15,
        ARRAYINFO = 0x100,
        BYTE = 17,
        FLOAT = 33, //0x21

        PsoPOINTER = 12,



        CCompositeEntityType = 1185771007, 
        scaleXY = 2627937847,
        scaleZ = 284916802,
        numChildren = 2793909385,
        childLodDist = 3398912973,
        portals = 2314725778,
        entitySets = 1169996080,
        timeFlags = 2248791340,
        rage__spdAABB = 4084721864,
        rage__fwGrassInstanceListDef = 2085051229,
        rage__fwGrassInstanceListDef__InstanceData = 3985044770,
        rage__fwPropInstanceListDef = 3120863088,
        NormalX = 3138065392,
        NormalY = 273792636,

        CImapDependency = 3501026914,
        CImapDependencies = 3240050401,
        CItypDependencies = 1515605584,
        CMapDataGroup = 3260758307, //PSO/YMF
        Bounds = 3298223272,
        HoursOnOff = 4190815249,
        itypName = 2890158180,
        packFileName = 4216494073,
        itypDepArray = 2410949350,





        //dexyfex manual guessing
        CScenarioPointRegion = 1492970064,
        CScenarioPointContainer = 2380938603,
        CScenarioPoint = 4103049490,
        CScenarioChain = 871314709,
        CScenarioChainingNode = 3340683255,
        CScenarioChainingEdge = 4255409560,
        Points = 702683191,
        Chains = 3254907796,
        rage__spdSphere = 1062159465,
        EdgeIds = 934700563,
        TypeNames = 3057471271,
        GroupNames = 2506712617,
        PedModelSetNames = 3020866217,
        VehicleModelSetNames = 3827910541,
        ModelSetId = 3361647288,
        LookUps = 1097626284,
        RequiredIMapNames = 1767860162,

        vPositionAndDirection = 4685037,
        CScenarioEntityOverride = 4213733800,
        EntityOverrides = 697469539,
        EntityPosition = 642078041,
        CScenarioPointCluster = 750308016,
        Clusters = 3587988394,
        ClusterSphere = 352461053,
        iInterior = 1975994103,
        iRequiredIMapId = 1229525587,
        iTimeTillPedLeaves = 2296188475,
        uAvailableInMpSp = 717991212,


        CPopGroupList = 738910261,

        CStreamingRequestFrame = 999226379,

        CVehicleWheel = 2964364979,




        CVfxPedInfoMgr = 2677836644,
        CVfxPedInfo = 3269469953,
        vfxPedInfos = 1918175602,

        CPedModelInfo__InitData = 3949383814,


        CVfxFogVolumeInfoMgr = 1633161012,
        CVfxFogVolumeInfo = 759946685,
        vfxFogVolumeInfos = 2287400076,

        CVfxWeaponInfoMgr = 623762845,
        CVfxWeaponInfo = 1271168564,

        CVfxInteriorInfoMgr = 4126959192,
        CVfxInteriorInfo = 998078140,
        vfxInteriorInfos = 3759474957,

        CVfxRegionInfoMgr = 3596444566,
        CVfxRegionInfo = 286275649,
        vfxRegionInfos = 4124078855,











        //dav90 suggestions
        AccelGrid = 3053155275,
        NavMode = 859022269,
        NavSpeed = 1419316113,
        NodeIndexTo = 2851806039,
        NodeIndexFrom = 3236798246,
        CScenarioPointLookUps = 3019621867,
        ANCHOR_MOUTH = 2032023579,
        ANCHOR_LEFT_HAND = 100074042,
        ANCHOR_RIGHT_HAND = 3693638868,
        ANCHOR_HIP = 2778755006,
        ANCHOR_LEFT_FOOT = 1100801960,
        ANCHOR_RIGHT_FOOT = 1776231225,
        mloFlags = 3590839912,
        floorId = 2187650609,
        timecycleName = 2724323497,
        secondaryTimecycleName = 3255324828,
        portalCount = 1105339827,
        //exteriorVisibiltyDepth = 552849982, //not correct = spelling error?
        attachedObjects = 2382704940,
        roomFrom = 4101034749,
        roomTo = 2607060513,
        mirrorPriority = 1185490713,
        audioOcclusion = 1093790004,
        dataSize = 2442753371,
        iCenterX = 48026296,
        iCenterY = 896907229,
        iCenterZ = 1597508449,
        iLength = 2854610661,
        iWidth = 168013536,
        iHeight = 3485277993,
        explosionName = 3301388915,
        explosionTag = 2653034051,
        explosionType = 3379115010,
        cornerA = 3302595027,
        cornerB = 2393877884,
        cornerC = 2692731164,
        cornerD = 4250372814,
        directionAmount = 1441249296,
        densityType = 235100599,
        volumeType = 4021175589,
        softness = 187712958,
        disturbanceType = 3802708370,
        radiusInner = 406390660,
        radiusOuter = 1814053978,
        minScale = 3662913353,
        maxScale = 803384552,
        objectHash = 1951307499,
        LoadSavePoints = 3016741991,
        MyPoints = 1170781136,
        iProbability = 2974610960,
        iScenarioGroup = 2180252673,
        EntityType = 1374199246,
        CStreamingRequestRecord = 135915278,
        Frames = 419044527,
        CommonSets = 4248405899,
        NewStyle = 2333392588,
        AddList = 327274266,
        RemoveList = 3372321331,
        CamPos = 357008256,
        CamDir = 210316193,
        Requests = 2743119154,
        compInfos = 592652859,
        propInfo = 2240851416,
        propMask = 2932859459,
        aTexData = 1251090986,
        clothData = 2464583091,
        distribution = 914976023,
        inclusions = 2172318933,
        aAnchors = 162345210,
        expressionMods = 942761829,
        texData = 4088935562,
        renderFlags = 4239582912,
        propFlags = 1066841901,
        anchorId = 2731224028,
        propId = 3817142252,
        inclusionId = 1938349561,
        exclusionId = 3819522186,
        weaponSlot = 1912311826,
        disableProjectileDriveby = 531190847,
        disableDriveby = 3038752585,
        NoSpawn = 2321493392,   //scenario point flags enum values
        TerritorialScenario = 763077056,
        InWater = 3157896680,
        OpenDoor = 2382141124,
        ExtendedRange = 324643703,
        ShortRange = 3717016373,
        HighPriority = 3426447659,
        IgnoreLoitering = 626032513,
        //ZoomTransformInformations = 3304563391, //this one doesn't make sense
        kOnlySp = 4171042740, //scenario spawn point availability enum
        kOnlyMp = 549935372,
        Direct = 1129153779, //scenario chain edge nav mode enum
        NavMesh = 4272634460,
        Roads = 177164187,
        //METAL_SOLID_LADDER = 1101797524,
        METAL_LIGHT_LADDER = 846330484,
        CComponentInfo = 1866571721,
        CAnchorProps = 2170383875,
        CBlockDesc = 3072355914,
        CClassNameOfItemType = 440716365, //array type for (PSO) MAP fields
        zones = 2319609287,
        spName = 4254542050,


        //from rubidium
        mpName = 2031203854,
        zoneName = 257000,



        //dilapidated list - from dav90 hash collider
        ActivateVehicleSiren = 3401359988,
        AerialVehiclePoint = 1653545417,
        MoveFollowMaster = 3724117664,
        AggressiveVehicleDriving = 2626064871,
        UseSearchlight = 1524211135,
        IgnoreWeatherRestrictions = 176469077,




        //from junctions.xml -dexy
        CJunctionTemplateArray = 313816480,
        CJunctionTemplate = 2985578477,
        Entries = 3580294544,
        iFlags = 1490815345,
        iNumJunctionNodes = 3730457984,
        iNumEntrances = 3629382379,
        iNumPhases = 4284697782,
        iNumTrafficLightLocations = 2024774002,
        fSearchDistance = 3543631740,
        fPhaseOffset = 33051442, //from dav90
        vJunctionMin = 4254986313,
        vJunctionMax = 2705763988,
        vJunctionNodePositions = 1140501121,
        Entrances = 2079778626,
        PhaseTimings = 970330902,
        TrafficLightLocations = 3688283693,
        vNodePosition = 137333670,
        iPhase = 1580401081,
        fStoppingDistance = 4131936721,
        fOrientation = 2674216667,
        fAngleFromCenter = 253800508,
        bCanTurnRightOnRedLight = 4189109284,
        bLeftLaneIsAheadOnly = 15530841,
        bRightLaneIsRightOnly = 1190125928,
        iLeftFilterLanePhase = 478748718,
        fStartTime = 1971943265,
        fDuration = 3674620953,
        iPosX = 681100199,
        iPosY = 1574841905,
        iPosZ = 176392061,


        //from openIV
        dependencies = 1013942340,
        hdTextureDist = 2908576588,
        clipDictionary = 424089489,
        physicsDictionary = 3553040380,
        priorityLevel = 647098393,
        ambientOcclusionMultiplier = 415356295,
        artificialAmbientOcclusion = 599844163,
        tintValue = 1015358759,
        contentFlags = 1785155637,
        streamingExtentsMin = 3710026271,
        streamingExtentsMax = 2720965429,
        entitiesExtentsMin = 477478129,
        entitiesExtentsMax = 1829192759,
        containerLods = 2935983381,
        boxOccluders = 3983590932,
        occludeModels = 2132383965,
        physicsDictionaries = 949589348,
        instancedData = 2569067561,
        carGenerators = 3254823756,
        LODLightsSOA = 1774371066,
        DistantLODLightsSOA = 2954466641,
        Ao = 2996378564,
        BatchAABB = 1859041902,
        InstanceList = 470289337,
        LodFadeStartDist = 2216273066,
        LodInstFadeRange = 1405992723,
        OrientToTerrain = 3341475578,
        ImapLink = 2142127586,
        PropInstanceList = 3551474528,
        GrassInstanceList = 255292381,
        numStreetLights = 3708891211,
        category = 2052871693,
        exportedBy = 1983184981,
        StartImapFile = 2462971690,
        EndImapFile = 2059586669,
        PtFxAssetName = 2497993358,
        punchInPhase = 3142377407,
        punchOutPhase = 2164219370,

        AvailabilityInMpSp = 2932681318,
        iTimeStartOverride = 591476992,
        iTimeEndOverride = 2688038523,
        TimeTillPedLeaves = 4073598194,
        instances = 274177522,
        flashiness = 3829693202,
        lightType = 482065968,
        groupId = 2501631252,
        cullingPlane = 1689591312,
        padding1 = 3180641850,
        padding2 = 2346113727,
        padding3 = 3521603295,
        volIntensity = 689780512,
        volSizeScale = 2029533327,
        volOuterColour = 2283994062,
        lightHash = 643049222,
        volOuterIntensity = 3008198647,
        coronaSize = 1705000075,
        volOuterExponent = 2758849250,
        lightFadeDistance = 1307926275,
        shadowFadeDistance = 1944267876,
        specularFadeDistance = 4150887048,
        volumetricFadeDistance = 2066998816,
        shadowNearClip = 954647178,
        coronaIntensity = 2292363771,
        coronaZBias = 2520359283,
        coneInnerAngle = 1163671864,
        coneOuterAngle = 4175029060,
        extents = 759134656,
        projectedTextureKey = 1076718994,
        timeAndStateFlags = 3112418278,
        coneOuterAngleOrCapExt = 3161894080,

        minExtents = 1731020657,
        maxExtents = 2554806840,

        orientX = 735213009,
        orientY = 979440342,
        perpendicularLength = 124715667,
        bodyColorRemap1 = 1429703670,
        bodyColorRemap2 = 1254848286,
        bodyColorRemap3 = 1880965569,
        bodyColorRemap4 = 1719152247,
        popGroup = 911358791,

        enableLimitAngle = 1979299226,
        startsLocked = 3204572347,
        canBreak = 2756786344,
        doorTargetRatio = 770433283,
        audioHash = 224069936,

        effectHash = 2982223448,
        materialType = 932754174,
        canGetOffAtTop = 564839673,
        canGetOffAtBottom = 923729576,

        manifestFlags = 1683136603,

        AT_DRB = 1956121915,
        AT_FRG = 2872363693,
        AT_DWD = 474212588,
        INTERIOR_DATA = 559321238,

        METAL_SOLID_LADDER = 1101797524,

        PRI_REQUIRED = 1943361227,
        PRI_OPTIONAL_HIGH = 3993616791,
        PRI_OPTIONAL_MEDIUM = 515598709,
        PRI_OPTIONAL_LOW = 329627604,


        ASSET_TYPE_UNINITIALIZED = 189734893,
        ASSET_TYPE_FRAGMENT = 571047911,
        ASSET_TYPE_DRAWABLE = 130075505,
        ASSET_TYPE_DRAWABLEDICTIONARY = 1580165652,
        ASSET_TYPE_ASSETLESS = 4161085041,


        //openIV carcols.ymt
        VehiclePlates = 593302648,
        Textures = 1767854039,
        TextureSetName = 539384795,
        DiffuseMapName = 1085051633,
        //NormalMapName = 2845714814, //already present
        FontExtents = 1008020858,
        MaxLettersOnPlate = 1247956775,
        FontColor = 1707432934,
        FontOutlineColor = 2386115193,
        IsFontOutlineEnabled = 3610161521,
        FontOutlineMinMaxDepth = 1248154675,
        DefaultTexureIndex = 3080794991,
        NumericOffset = 4285827253,
        AlphabeticOffset = 1050521113,
        SpaceOffset = 1314537973,
        RandomCharOffset = 2935763181,
        NumRandomChar = 3588975658,
        Colors = 721554909,
        metallicID = 2578478329,
        audioColor = 1773594779,
        audioPrefix = 2369251831,
        audioColorHash = 2318773127,
        audioPrefixHash = 319619186,
        colorName = 3636206675,
        MetallicSettings = 1425754958,
        specInt = 583457853,
        specFalloff = 4263701895,
        specFresnel = 3304136448,
        WindowColors = 923621137,
        Sirens = 2599949557,
        timeMultiplier = 1771951321,
        lightFalloffMax = 154568665,
        lightFalloffExponent = 1650161522,
        lightInnerConeAngle = 1576817313,
        lightOuterConeAngle = 3797248043,
        lightOffset = 1620490850,
        //textureName = 440050042,
        sequencerBpm = 1335282710,
        sequencer = 3240773244,
        leftHeadLight = 649479127,
        rightHeadLight = 1381853174,
        leftTailLight = 1551657213,
        rightTailLight = 3049986329,
        leftHeadLightMultiples = 3399909735,
        rightHeadLightMultiples = 3461946667,
        leftTailLightMultiples = 4275157148,
        rightTailLightMultiples = 2310746177,
        useRealLights = 804083006,
        delta = 1117510170,
        syncToBpm = 43887647,
        corona = 3191162493,
        faceCamera = 992261783,
        lightGroup = 2689509391,
        scaleFactor = 3961827348,
        light = 1118124053,
        spotLight = 1568651848,
        castShadows = 3640997727,
        livery2Names = 3280812844,
        GlobalVariationData = 4171652890,
        xenonLightColor = 4198188279,
        xenonCoronaColor = 4113209874,
        xenonLightIntensityModifier = 849227792,
        xenonCoronaIntensityModifier = 3145775573,







    }


}
